-- Penguininator
/*
	Behaves the same as vanilla, walks towards player and 
*/

PSO.info.enemies[MT_PENGUINATOR] = {
		
		name = "Penguinator",
		sprite = SPR_PENG,
		frame = A,
		painframe = A,
		
		bhp = 160,
		satk = 35,
		ratk = 10,
		tatk = 30,
		def = 25,
		exp = 7,
		weight = 1,
		
		
		drops = {
			-- Lv1-29
			{300, 1, 29, 1, 15},
			{"breaker", 1, 29, 1, 150},
			{"doublegladius", 1, 29, 1, 150},
			{"laser", 1, 29, 1, 150},
			{"canon", 1, 29, 1, 150},
			{"ulrod", 1, 29, 1, 150},
			{"dimate", 1, 29, 1, 25},

			-- Lv30-50
			{650, 30, 50, 1, 15},
			{"claw", 30, 50, 1, 50},
			{"alva claw", 30, 50, 1, 75},
			{"vita claw", 30, 50, 1, 100},
			{"winginator", 30, 50, 1, 200},
			{"rostig frame", 30, 50, 1, 30},
			{"fehler frame", 30, 50, 1, 100},
			{"digrinder", 30, 50, 1, 25},
			{"dimate", 30, 50, 1, 35},
			
		},
		
		stagger_duration = TICRATE/2,
		
		weakness = ELEM_FIRE,
		
		reset =	function(mo)
			mo.actiontimer = 0	-- reset action if we get staggered etc.
		end,
		
		thinker = function(mo)
			
			local diff = PSO.lib.questDifficulty()
			local chase_speed = (diff >= DIFF_HARD and 4 or 2)*FRACUNIT
			
			local lunge_potency = 200
			local max_dist = 768	-- must be within that dist to lunge
			
			local lunge_delay = TICRATE*(diff >= DIFF_HARD and 3 or 4)
			local lunge_duration = TICRATE*2
			
			PSO.lib.enemyManageAggro(mo)
			
			mo.sprite = SPR_PENG
			mo.frame = A
			
			if mo.target and mo.target.valid
				
				if mo.lungetimer
					
					if mo.lungetimer == lunge_duration
						mo.momz = FRACUNIT*4
					end
					
					if mo.lungetimer == lunge_duration-8

						local hx = mo.x + 64*cos(mo.angle)
						local hy = mo.y + 64*sin(mo.angle)
					
						local hb = PSO.lib.spawnHurtBox(hx, hy, mo.z, 80<<FRACBITS, 40<<FRACBITS, mo, lunge_potency, DMT_STRIKE, lunge_duration, RT_KNOCKBACK)
						mo.hitbox = hb
						hb.angle = mo.angle
						hb.pso.reactionstrength = 80
						
						P_InstaThrust(mo, mo.angle, FRACUNIT*18)
						
					elseif mo.lungetimer < lunge_duration-8

						local hx = mo.x + 64*cos(mo.angle)
						local hy = mo.y + 64*sin(mo.angle)
						
						mo.pso.superarmor = true
						
						if mo.hitbox and mo.hitbox.valid
							P_MoveOrigin(mo.hitbox, hx, hy, mo.z)
						end
						mo.frame = E
						
						if leveltime & 1
							P_SpawnGhostMobj(mo)
						end
						
						local d = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SPINDUST)
						d.momx = P_RandomRange(-4, 4)*FRACUNIT
						d.momy = P_RandomRange(-4, 4)*FRACUNIT
						d.momz = P_RandomRange(0, 4)*FRACUNIT

						mo.momx = $*97/100
						mo.momy = $*97/100
						
						if FixedHypot(mo.momx, mo.momy) < FRACUNIT*4
							P_InstaThrust(mo, 0, 0)
							if mo.hitbox and mo.hitbox.valid
								P_RemoveMobj(mo.hitbox)
							end
							mo.lungetimer = 0
							mo.pso.superarmor = nil
							return
						end
					end
					
					mo.lungetimer = $-1
					
					if not mo.lungetimer
						P_InstaThrust(mo, 0, 0)
						mo.pso.superarmor = nil
					end
					
					return
				end
				
				mo.waittimer = $ and $+1 or 1
				
				mo.angle = R_PointToAngle2(mo.x, mo.y, mo.target.x, mo.target.y)
				P_InstaThrust(mo, mo.angle, chase_speed)
				
				local frames = {A, B, A, C}
				local animtimer = mo.waittimer % 16
				mo.frame = frames[animtimer/4 +1] or A
				
				if R_PointToDist2(mo.x, mo.y, mo.target.x, mo.target.y) < max_dist*FRACUNIT
				and mo.waittimer > lunge_delay
					mo.waittimer = 0
					mo.lungetimer = lunge_duration

					P_InstaThrust(mo, 0, 0)
					
				end
			end
		end,	
}