-- SDURF
/*
	Hops in place 3 times and then hops towards the player
	
	HARD MODE: Hops 2 times instead of 3 before attacking
*/

PSO.info.enemies[MT_GFZFISH] = {
		
		name = "S.D.U.R.F.",
		sprite = SPR_FISH,
		frame = A,
		painframe = A,
		
		bhp = 80,
		satk = 30,
		ratk = 20,
		tatk = 20,
		def = 25,
		exp = 5,
		weight = 1,
		
		
		drops = {
			-- Lv 1-10
			{100, 1, 9, 1, 15},				-- meseta (100% mult) 2/5 (Lv1-10)
			{"sword", 1, 9, 1, 100},		-- sword: 	1/100 (Lv1-10)
			{"rifle", 1, 9, 1, 100},		-- rifle: 	1/100 (Lv1-10)
			{"rod", 1, 9, 1, 100},			-- rod: 	1/100 (Lv1-10)
			{"shell frame", 1, 9, 1, 20},
			
			{"monomate", 1, 9, 1, 25},	-- monomate: 1/5 (Lv1-10)
			
			-- Lv10-19
			
			{200, 10, 19, 1, 15},
			{"gigush", 10, 19, 1, 100},
			{"beam", 10, 19, 1, 100},
			{"cane", 10, 19, 1, 100},
			{"monomate", 10, 19, 1, 25},
			{"shell frame", 1, 9, 1, 15},

			-- Lv20-29
			{300, 20, 29, 1, 15},
			{"breaker", 20, 29, 1, 150},
			{"doublegladius", 20, 29, 1, 150},
			{"laser", 20, 29, 1, 150},
			{"canon", 20, 29, 1, 150},
			{"ulrod", 20, 29, 1, 150},
			{"monomate", 20, 29, 1, 25},
			{"reinforced frame", 20, 29, 1, 20},

			-- Lv30-50
			{650, 30, 50, 1, 15},
			{"doubliss", 30, 50, 1, 50},
			{"alva doubliss", 30, 50, 1, 75},
			{"vita doubliss", 30, 50, 1, 100},
			{"rostig frame", 30, 50, 1, 20},		
			{"aileron frame", 30, 50, 1, 50},
			{"dimate", 30, 50, 1, 35},
			
		},
		
		stagger_duration = TICRATE/2,
		
		weakness = ELEM_ELEC,
		
		reset =	function(mo)
			mo.actiontimer = 0	-- reset action if we get staggered etc.
			if not mo.hops
				mo.hops = 1
			end
		end,
		
		thinker = function(mo)
			
			local diff = PSO.lib.questDifficulty()
			local attack_potency = 250
			local attack_height = 24
			local attack_airtime = TICRATE
			local attack_movespeed = 12
			local attack_maxdist = 1024
			
			local hop_amounts = (diff >= DIFF_HARD and 2 or 3)
			local hop_height = 8
			
			PSO.lib.enemyManageAggro(mo)
			
			mo.sprite = SPR_FISH
			mo.frame = A
			
			if mo.hops == nil
				mo.hops = hop_anounts
			end
			
			if mo.hops
				
				if P_IsObjectOnGround(mo)
					mo.hops = $-1
					
					-- don't try to attack a non existant target
					if not mo.target or not mo.target.valid
						mo.hops = max(1, $)
					end
					
					if mo.hops
						mo.momz = hop_height*mo.scale
					else
						-- attack!!
						local dist = R_PointToDist2(mo.x, mo.y, mo.target.x, mo.target.y)
						
						if dist > attack_maxdist*mo.scale
							mo.momz = hop_height*mo.scale
							mo.hops = 1
							return
						end
						
						--mo.momz = attack_height*mo.scale
						mo.angle = R_PointToAngle2(mo.x, mo.y, mo.target.x, mo.target.y)
						P_InstaThrust(mo, mo.angle, dist/attack_airtime /2)
						mo.momz = -FixedMul((P_GetMobjGravity(mo)*attack_airtime)/2, mo.scale) *2
						mo.z = $ + mo.scale*8
					end
				end
			else
				-- attacking
				if leveltime & 1
					local g = P_SpawnGhostMobj(mo)
					g.rollangle = mo.rollangle
					g.colorized = true
					g.color = SKINCOLOR_BLUE
				end
				
				mo.rollangle = $ + ANG1*33
				mo.frame = B
				
				if P_IsObjectOnGround(mo)
					P_InstaThrust(mo, 0, 0)
					mo.rollangle = 0
					
					local hb = PSO.lib.spawnHurtBox(mo.x, mo.y, mo.z - mo.scale*4, 180<<FRACBITS, 40<<FRACBITS, mo, attack_potency, DMT_STRIKE, 8, RT_KNOCKBACK)
					hb.pso.reactionradialangle = true
						
					for i = 1, 8
						local dust = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SPINDUST)
						dust.angle = (360/8)*i *ANG1
						P_InstaThrust(dust, dust.angle, FRACUNIT*16)
					end
						
					S_StartSound(mo, sfx_pstop)
					mo.hops = hop_amounts
				end
			end
		end,	
}