freeslot("MT_PSO_JUMPPAD", "MT_PSO_JUMPTARGET", "SPR_JMPD")

mobjinfo[MT_PSO_JUMPPAD] = {
	doomednum = 2512,
	spawnstate = S_THOK,
	spawnhealth = 1000,
	height = 64<<FRACBITS,
	radius = 48<<FRACBITS,
	flags = MF_RUNSPAWNFUNC,
}

mobjinfo[MT_PSO_JUMPTARGET] = {
	doomednum = 2513,
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	height = 1,
	radius = 1,
	flags = MF_NOCLIP|MF_NOGRAVITY|MF_NOBLOCKMAP,
}

addHook("MobjThinker", function(mo)
		
	if not mo.extravalue1
	and leveltime == 4	-- bit of a hack, wait for all mobjs to have spawned.
		
		-- scan for MT_PSO_JUMPTARGET
		for m in mobjs.iterate()
			if m and m.valid and m.type == MT_PSO_JUMPTARGET
			and m.mtangle == mo.mtangle
				mo.target = m
				mo.angle = R_PointToAngle2(mo.x, mo.y, m.x, m.y) - ANG1*90 +ANG1*180
				break
			end
		end
		
		mo.pso = {name = "Jump Pad"}
		mo.tics = -1
		mo.fuse = -1
		mo.z = $ + FRACUNIT	-- avoid z fighting with the floor please lol
		mo.extravalue1 = 1
	end
	
	mo.sprite = SPR_JMPD
	
	local cycle = leveltime%(TICRATE*2)
	
	if cycle < TICRATE*3/2
		mo.frame = A
	else
		mo.frame = leveltime & 1
	end
	
	mo.flags2 = $|MF2_SPLAT
	mo.renderflags = $|RF_FLOORSPRITE|RF_NOSPLATBILLBOARD
		
end, MT_PSO_JUMPPAD)

local jump_pad_duration = TICRATE*2

PSO.lib.playerUseJumpPad = function(p, jpad)
	
	if not jpad.target
	or not jpad.target.valid
	or p.pso.jumppad
		return
	end
	
	S_StartSound(p.mo, sfx_nbmper)
	
	-- set our target.
	p.pso.jumppad = jpad.target
	p.pso.jumppadtimer = 1
	p.pso.jumppadstop = nil
	
	local ang = R_PointToAngle2(jpad.x, jpad.y, jpad.target.x, jpad.target.y)
	p.drawangle = ang
	P_MoveOrigin(p.mo, jpad.x, jpad.y, jpad.z)
	
	-- set our momentums etc...
	local airtime = jump_pad_duration
	local dist = R_PointToDist2(jpad.x, jpad.y, jpad.target.x, jpad.target.y)
	local zdist = jpad.target.z - jpad.z
	local gravity = P_GetMobjGravity(p.mo)
	
	dist = max(p.mo.scale*32, $ - FixedMul(zdist, -gravity)) -- cheating.
	
	local horzspd = dist / airtime	-- this one is easy
	
	-- z component
	-- gravity is linear and is just added each frame, so let's compute how much height we're realistically losing over the course of the duration:
	local heightloss = gravity*airtime
	local vertical = -(heightloss/2) + zdist/32	-- we must compensate it
	
	
	P_InstaThrust(p.mo, ang, horzspd)
	p.mo.momz = vertical
	p.mo.state = S_PLAY_SPRING
	--p.mo.flags = $|MF_NOCLIP|MF_NOCLIPHEIGHT
end