freeslot("MT_PSO_NPC", "MT_PSO_NPC_INTERACT")

mobjinfo[MT_PSO_NPC] = {
	
	doomednum = 2602,
	spawnstate = S_PLAY_STND,
	spawnhealth = 1000,
	flags = MF_SOLID,
	radius = 32<<FRACBITS,
	height = 64<<FRACBITS,
}

mobjinfo[MT_PSO_NPC_INTERACT] = {
	doomednum = -1,
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT,
	radius = 64<<FRACBITS,
	height = 64<<FRACBITS,
}

local npc_menu_names = {
	
	"QUEST COUNTER",
	"TYPE COUNTER",
	"TEKKER",
	"SHOP",
	"STORAGE",
	"DOCTOR",
	"WAITER"
}

local npc_menus = {
	"quest_map",
	"type",
	nil,	--"tekker",
	"shop",
	"storage",
	"heal",
	nil,	--"food",
}

addHook("MapThingSpawn", function(mo, mt)
	
	-- how many skins we got?
	local i = 0
	while skins[i] and skins[i].valid
		i = $+1
	end
	
	local skinnum = P_RandomRange(0, i-1)
	mo.skin = skins[skinnum].name or "sonic"
	mo.color = P_RandomRange(1, SKINCOLOR_ROSY)	-- uuuuuh yeah that'll do lol
	mo.tics = -1
	mo.shadowscale = FRACUNIT/2
	
	local extrainfo
	if udmf
		extrainfo = mt.args[5]
	else
		extrainfo = mt.extrainfo
	end
	
	if extrainfo
		local x = mo.x + 128*cos(mt.angle*ANG1)
		local y = mo.y + 128*sin(mt.angle*ANG1)
		local it = P_SpawnMobj(x, y, mo.z, MT_PSO_NPC_INTERACT)
		it.target = mo
		mo.pso = {name = (npc_menu_names[extrainfo] or "INVALID")}
		
	end
	
	-- Code courtesy of Sal
	-- Spawn followmobjs:
    if (skins[mo.skin].followitem > 0)
        local followitem = skins[mo.skin].followitem
        local followstate = mobjinfo[followitem].spawnstate

        if (followitem == MT_TAILSOVERLAY)
            -- Welp I wasn't expecting that
            followstate = S_TAILSOVERLAY_STAND
        end

        if (followstate != S_NULL)
            local a = mt.angle * ANG1
            local followx = mo.x + P_ReturnThrustX(mo, a, -FRACUNIT)
            local followy = mo.y + P_ReturnThrustY(mo, a, -FRACUNIT)
            local followz = mo.z + 3*FRACUNIT
            local followmobj = P_SpawnMobj(followx, followy, followz, followitem)
            followmobj.angle = a
            followmobj.skin = mo.skin
            followmobj.color = mo.color

            followmobj.state = followstate

            mo.tracer = followmobj
            followmobj.tracer = mo
        end
    end	
	
end, MT_PSO_NPC)

PSO.lib.NPCInteract = function(p, mo)
	if npc_menus[mo.extrainfo]
		PSO.lib.openMenu(p, npc_menus[mo.extrainfo] or "")
	elseif p == consoleplayer
		PSO.lib.spawnChatBox(mo, mo.pso.name, "Sorry, we aren't open yet! Come back at a later update!")
	end
end