freeslot("sfx_heal")

PSO.info.items["skipto_canyon"] = {
		name = "T/ Canyon",
		type = IT_CONSUMABLE,
		rarity = 10,
		
		carrylimit = 1,
		cost = 1,
		
		desc = "Consumable item, grants 650 EXP, items and unlocks new areas on use.",
		
		-- if false, the item can't be used.
		canuse = 	function(p)
						return true
					end,
		
		use =	function(p)
					PSO.lib.givePlayerExp(p, 650)
					
					local items = {"gigush", "doublerapier", "beam", "spread", "baton", "shell frame"}
					
					for i = 1, #items
						local it = PSO.lib.makeItem(items[i], {ELEM_ICE, 10})
						PSO.lib.playerGetItem(p, it, 1)
					end
					PSO.lib.rollPlayerShop(p)
					
					PSO.lib.unlockQuest(2, 2, DIFF_NORMAL)
					PSO.lib.unlockQuest(2, 3, DIFF_NORMAL)
					PSO.lib.unlockQuest(3, 1, DIFF_NORMAL)
				end,
}

PSO.info.items["skipto_peaks"] = {
		name = "T/ Peaks",
		type = IT_CONSUMABLE,
		rarity = 10,
		
		carrylimit = 1,
		cost = 1,
		
		desc = "Consumable item, grants 7,500 EXP, items and unlocks new areas on use.",
		
		-- if false, the item can't be used.
		canuse = 	function(p)
						return true
					end,
		
		use =	function(p)
					PSO.lib.givePlayerExp(p, 7500)
					
					local items = {"pine", "doubliss", "shot", "shooter", "crescent", "cutter", "beamgun", "scepter", "tutel frame", "unit_hp_1", "unit_pp_1", "unit_satk_1", "unit_tatk_1", "unit_ratk_1"}
					
					for i = 1, #items
						local it = PSO.lib.makeItem(items[i], {ELEM_ICE, 10})
						PSO.lib.playerGetItem(p, it, 1)
					end
					PSO.lib.rollPlayerShop(p)

					PSO.lib.unlockQuest(2, 2, DIFF_NORMAL)
					PSO.lib.unlockQuest(2, 3, DIFF_NORMAL)
					PSO.lib.unlockQuest(3, 1, DIFF_NORMAL)
					PSO.lib.unlockQuest(3, 2, DIFF_NORMAL)
					PSO.lib.unlockQuest(3, 3, DIFF_NORMAL)
					PSO.lib.unlockQuest(4, 1, DIFF_NORMAL)
				end,
}

PSO.info.items["skipto_depths"] = {
		name = "T/ Depths",
		type = IT_CONSUMABLE,
		rarity = 10,
		
		carrylimit = 1,
		cost = 1,
		
		desc = "Consumable item, grants 15,000 EXP, items and unlocks new areas on use.",
		
		-- if false, the item can't be used.
		canuse = 	function(p)
						return true
					end,
		
		use =	function(p)
					PSO.lib.givePlayerExp(p, 15000)
					
					local items = {"trigrinder", "trigrinder", "trigrinder", "trigrinder", "trigrinder", "trigrinder", "trigrinder", "trigrinder", "alva pine", "alva doubliss", "alva shot", "alva shooter", "alva crescent", "alva cutter", "alva beamgun", "alva scepter", "knight frame", "unit_hp_2", "unit_pp_2", "unit_satk_2", "unit_tatk_2", "unit_ratk_2"}
					
					for i = 1, #items
						--print(items[i])
						local it = PSO.lib.makeItem(items[i], {ELEM_ICE, 10})
						PSO.lib.playerGetItem(p, it, 1)
					end
					PSO.lib.rollPlayerShop(p)

					PSO.lib.unlockQuest(2, 2, DIFF_NORMAL)
					PSO.lib.unlockQuest(2, 3, DIFF_NORMAL)
					PSO.lib.unlockQuest(3, 1, DIFF_NORMAL)
					PSO.lib.unlockQuest(3, 2, DIFF_NORMAL)
					PSO.lib.unlockQuest(3, 3, DIFF_NORMAL)
					PSO.lib.unlockQuest(4, 1, DIFF_NORMAL)
					PSO.lib.unlockQuest(4, 2, DIFF_NORMAL)
					PSO.lib.unlockQuest(4, 3, DIFF_NORMAL)
					PSO.lib.unlockQuest(5, 1, DIFF_NORMAL)
					
				end,
}

PSO.info.items["skipto_hard"] = {
		name = "T/ HARDMODE",
		type = IT_CONSUMABLE,
		rarity = 10,
		
		carrylimit = 1,
		cost = 1,
		
		desc = "Consumable item, grants 21,000 EXP, items and unlocks new areas on use.",
		
		-- if false, the item can't be used.
		canuse = 	function(p)
						return true
					end,
		
		use =	function(p)
					PSO.lib.givePlayerExp(p, 21000)
					
					local items = {"trigrinder", "trigrinder", "trigrinder", "trigrinder", "trigrinder", "trigrinder", "trigrinder", "trigrinder", "alva pine", "alva doubliss", "alva shot", "alva shooter", "alva crescent", "alva cutter", "alva beamgun", "alva scepter", "knight frame", "unit_hp_2", "unit_pp_2", "unit_satk_2", "unit_tatk_2", "unit_ratk_2"}
					
					for i = 1, #items
						--print(items[i])
						local it = PSO.lib.makeItem(items[i], {ELEM_ICE, 10})
						PSO.lib.playerGetItem(p, it, 1)
					end
					PSO.lib.rollPlayerShop(p)
					
					PSO.lib.unlockQuest(2, 1, DIFF_HARD)
					PSO.lib.unlockQuest(2, 2, DIFF_NORMAL)
					PSO.lib.unlockQuest(2, 3, DIFF_NORMAL)
					PSO.lib.unlockQuest(3, 1, DIFF_NORMAL)
					PSO.lib.unlockQuest(3, 2, DIFF_NORMAL)
					PSO.lib.unlockQuest(3, 3, DIFF_NORMAL)
					PSO.lib.unlockQuest(4, 1, DIFF_NORMAL)
					PSO.lib.unlockQuest(4, 2, DIFF_NORMAL)
					PSO.lib.unlockQuest(4, 3, DIFF_NORMAL)
					PSO.lib.unlockQuest(5, 1, DIFF_NORMAL)
					
				end,
}

local atomizer_radius = 896

PSO.info.items["star atomizer"] = {
		name = "Star Atomizer",
		type = IT_CONSUMABLE,
		rarity = 6,
		paletteico = "H_ATMZR1",	-- must be set for a consumable to be usable on the palette!
		
		carrylimit = 5,
		cost = 2000,
		
		desc = "Consumable item, heals the user as well as nearby allies for half of their max HP.",
		
		-- if false, the item can't be used.
		canuse = 	function(p)
						for pl in players.iterate
							if pl.mo and pl.mo.valid and pl.pso
							and R_PointToDist2(p.mo.x, p.mo.y, pl.mo.x, pl.mo.y) < atomizer_radius*p.mo.scale
							and pl.pso.hp < pl.pso.maxhp
							and pl.pso.hp > 0	-- don't count dead players lol
								return true
							end	-- if any player can be healed we good
						end
					end,
		
		use =	function(p)
					for pl in players.iterate
						if pl.mo and pl.mo.valid and pl.pso
						and R_PointToDist2(p.mo.x, p.mo.y, pl.mo.x, pl.mo.y) < atomizer_radius*p.mo.scale
						and pl.pso.hp > 0	-- don't heal dead players
							PSO.lib.healObject(pl.mo, pl.mo, pl.pso.maxhp/2)
						end	-- if any player can be healed we good
					end
					
					for i = 1, 8
						local s = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_SUPERSPARK)
						P_InstaThrust(s, (360/8)*i*ANG1, p.mo.scale*32)
					end
					
					S_StartSound(p.mo, sfx_heal)
				end,
}

PSO.info.items["moon atomizer"] = {
		name = "Moon Atomizer",
		type = IT_CONSUMABLE,
		rarity = 6,
		paletteico = "H_ATMZR2",	-- must be set for a consumable to be usable on the palette!
		
		carrylimit = 5,
		cost = 2000,
		
		desc = "Consumable item, revives incapacitated allies around the user with half of their max HP.",
		
		-- if false, the item can't be used.
		canuse = 	function(p)
						for pl in players.iterate
							if pl.mo and pl.mo.valid and pl.pso
							and R_PointToDist2(p.mo.x, p.mo.y, pl.mo.x, pl.mo.y) < atomizer_radius*p.mo.scale
							and pl.pso.hp <= 0
								return true
							end	-- if any player can be healed we good
						end
					end,
		
		use =	function(p)
					for pl in players.iterate
						if pl.mo and pl.mo.valid and pl.pso
						and R_PointToDist2(p.mo.x, p.mo.y, pl.mo.x, pl.mo.y) < atomizer_radius*p.mo.scale
						and pl.pso.hp <= 0
							PSO.lib.revivePlayer(pl, p)
						end
					end
					
					for i = 1, 8
						local s = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_SUPERSPARK)
						P_InstaThrust(s, (360/8)*i*ANG1, p.mo.scale*32)
					end
					
					S_StartSound(p.mo, sfx_heal)
				end,
}

PSO.info.items["monomate"] = {
		name = "Monomate",
		type = IT_CONSUMABLE,
		rarity = 1,
		paletteico = "H_MATE1",	-- must be set for a consumable to be usable on the palette!
		
		carrylimit = 10,
		cost = 50,
		
		desc = "Consumable item, heals a third of your HP. Can be set to your Action Palette.",
		
		-- if false, the item can't be used.
		canuse = 	function(p)
						return p.pso.hp < p.pso.maxhp
					end,
		
		use =	function(p)
					PSO.lib.healObject(p.mo, p.mo, p.pso.maxhp/3)
					S_StartSound(p.mo, sfx_heal)
				end,
}

PSO.info.items["dimate"] = {
		name = "Dimate",
		type = IT_CONSUMABLE,
		rarity = 2,
		paletteico = "H_MATE2",	-- must be set for a consumable to be usable on the palette!
		
		carrylimit = 10,
		cost = 250,
		
		desc = "Consumable item, heals two thirds of your HP. Can be set to your Action Palette.",

		canuse = 	function(p)
						return p.pso.hp < p.pso.maxhp
					end,

		use =	function(p)
					PSO.lib.healObject(p.mo, p.mo, p.pso.maxhp*2/3)
					S_StartSound(p.mo, sfx_heal)
				end,
		
}

PSO.info.items["trimate"] = {
		name = "Trimate",
		type = IT_CONSUMABLE,
		rarity = 3,
		paletteico = "H_MATE3",	-- must be set for a consumable to be usable on the palette!
		
		carrylimit = 10,
		cost = 1000,
		
		desc = "Consumable item, heals all your HP. Can be set to your Action Palette.",

		canuse = 	function(p)
						return p.pso.hp < p.pso.maxhp
					end,

		use =	function(p)
					PSO.lib.healObject(p.mo, p.mo, p.pso.maxhp)
					S_StartSound(p.mo, sfx_heal)
				end,
		
}

PSO.info.items["scape doll"] = {
		name = "Scape Doll",
		type = IT_CONSUMABLE,
		rarity = 7,
		cost = 10000,
		carrylimit = 1,
		
		desc = "Rare item resembling a doll that can revive its owner should they get incapacitated. Best to hold on to it!",
}

PSO.info.items["monogrinder"] = {
		name = "Monogrinder",
		type = IT_CONSUMABLE,
		rarity = 5,
		grinder = 1,
		cost = 1000,
		
		desc = "Consumable item. Select a weapon or an armour to enhance its ATK or DEF by 1 level to a maximum of 10.",
}

PSO.info.items["digrinder"] = {
		name = "Digrinder",
		type = IT_CONSUMABLE,
		rarity = 6,
		grinder = 2,
		cost = 5000,
		
		desc = "Consumable item. Select a weapon or an armour to enhance its ATK or DEF by 2 levels to a maximum of 10.",
}

PSO.info.items["trigrinder"] = {
		name = "Trigrinder",
		type = IT_CONSUMABLE,
		rarity = 7,
		grinder = 3,
		cost = 12500,
		
		desc = "Consumable item. Select a weapon or an armour to enhance its ATK or DEF by 3 levels to a maximum of 10.",
}