-- Player prefs IO

COM_AddCommand("pso_prefs_toggles", function(p, arglockon, argapal, argbpal)
	
	if not p return end
	if not p.pso return end
	
	local vals = {arglockon, argapal, argbpal}
	local vars = {"toggle_lockon", "toggle_apalette", "toggle_bpalette"}
	
	for i = 1, #vals
		local val = false
		local argv = vals[i]:lower()
		
		if tonumber(vals[i]) 
		or argv == "yes" or argv == "true" or argv == "on"
			val = true
		end
		
		p.pso[vars[i]] = val
	end
	
	PSO.lib.playerSavePrefs(p)
end)

local function splitstr(str, sep)
	local t={}
	for s in string.gmatch(str, "([^"..sep.."]+)") do
		table.insert(t, s)
	end
	return t
end

local ipt_list = {IPT_CONFIRM, IPT_BACK, IPT_INTERACT, IPT_ATTACK, IPT_ATTACK2, IPT_PALETTE, IPT_SECONDPALETTE, IPT_LOCKON, IPT_MENU}
COM_AddCommand("pso_prefs_inputs", function(p, arg)
	
	if not p return end
	if not p.pso return end
	
	-- hack
	if not arg
		p.pso.alloweditinputs = nil
		return
	end
	
	-- player must be allowed to edit inputs
	-- makes it so they can't fuck their game.
	if not p.mo or not p.pso.alloweditinputs
		CONS_Printf(p, "Cannot edit inputs manually through this command.")
		return
	end
	
	p.pso.alloweditinputs = nil
	
	local args = splitstr(arg, " ")
	
	for i = 1, #args
		local val = tonumber(args[i])
		p.pso.inputs[ipt_list[i]] = val
	end
	
	PSO.lib.playerSavePrefs(p)
end)

rawset(_G, "cv_useminimap",  CV_RegisterVar({
	name = "pso_prefs_minimap",
	defaultvalue = 1,
	PossibleValue = CV_OnOff,
}))

rawset(_G, "cv_maprotation",  CV_RegisterVar({
	name = "pso_prefs_minimaprotation",
	defaultvalue = 0,
	PossibleValue = CV_OnOff,
}))

PSO.lib.playerSavePrefs = function(p)
	if p == consoleplayer
		local f = io.openlocal("client/"..PSO.info.playerPrefFile, "w")
		-- the pref file only has 2 lines thankfully so it's very fast!
		
		-- toggles:
		local str = "pso_prefs_toggles"
		local vars = {"toggle_lockon", "toggle_apalette", "toggle_bpalette"}
		for i = 1, #vars
			if p.pso[vars[i]]
				str = $.." 1"
			else
				str = $.." 0"
			end
		end
		
		str = $.."\n"
		f:write(str)
		
		str = "pso_prefs_inputs \""
		for i = 1, #ipt_list
			
			str = $..(p.pso.inputs[ipt_list[i]])
			
			if i < #ipt_list
				str = $.." "
			end
		end
		
		str = $.."\""
		str = $.."\n"
		f:write(str)
		
		str = "pso_prefs_minimap "..cv_useminimap.value.."\n"
		f:write(str)
		
		str = "pso_prefs_minimaprotation "..cv_maprotation.value.."\n"
		f:write(str)
		
		f:close()
	end
end

PSO.lib.playerLoadPrefs = function(p)
	
	p.pso.alloweditinputs = true
	
	if p == consoleplayer
		local f = io.openlocal("client/"..PSO.info.playerPrefFile, "r")
		if not f return end	-- file was not created, first time joiner / fine w default config? :)
		
		local sent_inputs
		
		-- execute the contents of the file
		local r = f:read()
		while r
			
			if r:find("pso_prefs_inputs")
				sent_inputs = true
			end
			
			COM_BufInsertText(p, r)
			r = f:read()
		end
		
		-- send this command with no argument to make sure to remove the input edition flag
		if not sent_inputs
			COM_BufInsertText(p, "pso_prefs_inputs")
		end
		f:close()
	end
end

