-- Sword photon arts
PSO.info.photonArts = {}

freeslot("SPR_STRL")

local function sword_trail(mo, pos, prevswordpos)
	
	local wep = PSO.lib.getPlayerActiveWeapon(mo.player)
	local winfo = PSO.lib.itemInfo(wep)
	
	for i = 0, 5
							
		local x = PSO.lib.lerp(mo.x + FixedMul(prevswordpos[1], mo.scale), mo.x + FixedMul(pos[2], mo.scale), FRACUNIT/5 *i)
		local y = PSO.lib.lerp(mo.y + FixedMul(prevswordpos[2], mo.scale), mo.y + FixedMul(pos[3], mo.scale), FRACUNIT/5 *i)
		local z = PSO.lib.lerp(mo.z + FixedMul(prevswordpos[3], mo.scale), mo.z + FixedMul(pos[4], mo.scale), FRACUNIT/5 *i)
		local a = PSO.lib.lerp(prevswordpos[4], pos[6], FRACUNIT/5 *i)
							
		local trail = P_SpawnMobj(x, y, z - mo.scale*8, MT_THOK)
		
		if pos[7] and pos[7].use
			P_CreateFloorSpriteSlope(trail)
						
			trail.flags2 = $ | MF2_SPLAT
			trail.renderflags = $|RF_FLOORSPRITE|RF_SLOPESPLAT|RF_NOSPLATBILLBOARD
			trail.floorspriteslope.o = pos[7].o
			trail.floorspriteslope.xydirection = pos[7].xy
			trail.floorspriteslope.zangle = pos[7].za
						
			trail.sprite = SPR_STRL
			trail.frame = A|TR_TRANS30
			
			trail.angle = 0	
			trail.rollangle = a

		else
			trail.sprite = SPR_STRL
			trail.frame = A|TR_TRANS30|FF_PAPERSPRITE
			trail.angle = mo.player.drawangle + pos[5]
			trail.rollangle = a
		end
		
		trail.tics = 10
		trail.fuse = 10						
		trail.color = winfo.effectcolor or SKINCOLOR_CYAN
	end
end

PSO.info.photonArts["sword_normal"] = {
		name = "Attack",
		desc = "A wide swing that can be chained up to 3 times to launch alternative attacks. Restores PP on hit.",
		cost = 0,
		potency = 275,
		speed = 20,		-- speed % multiplier.
						-- 100: full speed
						-- 0: stand still
		
		combo = TICRATE*20,	-- hack for the 3-hit combo
		icon = "H_SWATK1",

		use = 	function(p, timer, hold, input, combo)
					
					local mo = p.mo
					-- rifle is always weapon slot 1
					local pos = p.pso.weaponpos[1]
					local potency = PSO.info.photonArts[p.pso.action].potency
					local winfo = PSO.lib.itemInfo(PSO.lib.getPlayerActiveWeapon(p))
					
					-- set pos floorsprite
					
					-- for interpolation.
					local prevswordpos = {
						pos[2],
						pos[3],
						pos[4],
						pos[6],	-- rollangle
					}
					
					-- slash 1:
					if not combo
						pos[7] = {
							use = true,
							o = {x = mo.x, y = mo.y, z = mo.z + mo.height/2},	-- the center of the slope is the center of the player.
							xy = p.drawangle + ANG1*90,	-- tilt sideways
							za = ANG1*30,				-- tilt by 30 degrees
						}
						
						local ang

						if mo.swordangle == nil
							mo.swordangle = 0
						end
						
						if timer < 3
							mo.swordangle = -ANG1*120
						elseif timer < TICRATE/2
							local nt = timer-3
							mo.swordangle = $ + max(0, ANG1*(30 - (nt-2)*4))
						end
						
						local ang = p.drawangle + mo.swordangle
						local x = 64 * cos(ang)
						local y = 64 * sin(ang)
						
						pos[2] = x
						pos[3] = y
						pos[4] = mo.height/2
						pos[5] = 0
						pos[6] = ang + ANG1*90
						
						-- damage box:
						if timer == TICRATE/4
							local x = mo.x + FixedMul(mo.scale, 100*cos(p.drawangle))
							local y = mo.y + FixedMul(mo.scale, 100*sin(p.drawangle))
							
							--(x, y, z, w, t, source, potency, dtype, duration)
							local hb = PSO.lib.spawnHurtBox(x, y, mo.z, 140<<FRACBITS, 40<<FRACBITS, mo, potency, DMT_STRIKE, 8)
							hb.pso.potency = potency	-- normals shouldn't benefit from PA%
							hb.pso.ppregen = 10
							hb.pso.locks = 4
							hb.angle = p.drawangle
							
							if winfo.sound
								S_StartSound(mo, winfo.sound)
							end
						end
						
						if timer > TICRATE/2
						and timer < TICRATE*20
							p.pso.actiontimer = TICRATE*30 - TICRATE/4
						end
					
					-- slash 2:
					elseif combo == 1
						pos[7] = {
							use = true,
							o = {x = mo.x, y = mo.y, z = mo.z + mo.height/2},	-- the center of the slope is the center of the player.
							xy = p.drawangle - ANG1*90,	-- tilt sideways
							za = ANG1*30,				-- tilt by 30 degrees
						}
						
						local ang

						if mo.swordangle == nil
							mo.swordangle = 0
						end
						
						if timer < 3
							mo.swordangle = ANG1*120
						elseif timer < TICRATE/2
							local nt = timer-3
							mo.swordangle = $ - max(0, ANG1*(30 - (nt-2)*4))
						end
						
						local ang = p.drawangle + mo.swordangle
						local x = 64 * cos(ang)
						local y = 64 * sin(ang)
						
						pos[2] = x
						pos[3] = y
						pos[4] = mo.height/2
						pos[5] = 0
						pos[6] = ang + ANG1*90

						-- damage box:
						if timer == TICRATE/4
							local x = mo.x + FixedMul(mo.scale, 100*cos(p.drawangle))
							local y = mo.y + FixedMul(mo.scale, 100*sin(p.drawangle))
							
							--(x, y, z, w, t, source, potency, dtype, duration)
							local hb = PSO.lib.spawnHurtBox(x, y, mo.z, 140<<FRACBITS, 40<<FRACBITS, mo, potency, DMT_STRIKE, 8)
							hb.pso.potency = potency	-- normals shouldn't benefit from PA%
							hb.pso.ppregen = 10
							hb.pso.locks = 4
							hb.angle = p.drawangle
							
							if winfo.sound
								S_StartSound(mo, winfo.sound)
							end
						end
						
						if timer > TICRATE/2
						and timer < TICRATE*20
							p.pso.actiontimer = TICRATE*30 - TICRATE/4
						end					
					
					elseif combo == 2
						
						p.pso.actionspeed = 0
						
						pos[7] = {
							use = true,
							o = {x = mo.x, y = mo.y, z = mo.z + mo.height/2},	-- the center of the slope is the center of the player.
							xy = 0,
							za = 0,
						}
						
						local ang

						if mo.swordangle == nil
							mo.swordangle = 0
						end
						
						if timer < 3
							mo.swordangle = -ANG1*120
						elseif timer < TICRATE
							local nt = timer-3
							mo.swordangle = $ + max(0, ANG1*(47 - (nt-2)*3))
						end
						
						local ang = mo.angle + mo.swordangle
						p.drawangle = ang
						local x = 32 * cos(ang)
						local y = 32 * sin(ang)
						
						pos[2] = x
						pos[3] = y
						pos[4] = mo.height/2
						pos[5] = 0
						pos[6] = ang + ANG1*40

						-- damage box:
						if timer == TICRATE/4
							--(x, y, z, w, t, source, potency, dtype, duration)
							local hb = PSO.lib.spawnHurtBox(mo.x, mo.y, mo.z, 340<<FRACBITS, 40<<FRACBITS, mo, potency + 4, DMT_STRIKE, 8, RT_KNOCKBACK)
							hb.pso.potency = potency	-- normals shouldn't benefit from PA%
							hb.pso.ppregen = 15
							hb.pso.locks = 6
							hb.pso.reactionradialangle = true
							
							if winfo.sound
								S_StartSound(mo, winfo.sound)
							end
						end
						
						if timer == TICRATE	
							return true
						end
					end
					
					-- sword trail:
					if timer > 1
						sword_trail(mo, pos, prevswordpos)
					end
					
					if timer == 30*TICRATE
						return true
					end
					
					--P_SpawnMobj(mo.x+pos[2], mo.y+pos[3], mo.z+pos[4], MT_THOK)
					
				end,
}

PSO.info.photonArts["sword_pa_spindrop"] = {
		name = "Spin Drop",
		desc = "A forward spinning jump culminating in a power slash slamming the ground.",
		cost = 25,
		potency = 850,
		speed = 0,		-- speed % multiplier.
						-- 100: full speed
						-- 0: stand still
		
		icon = "H_SWATK4",
		
		use = 	function(p, timer, hold, input, combo)
					
					local slamtime = TICRATE
					
					local mo = p.mo
					-- rifle is always weapon slot 1
					local pos = p.pso.weaponpos[1]
					local potency = PSO.info.photonArts[p.pso.action].potency
					local wep = PSO.lib.getPlayerActiveWeapon(p)
					local winfo = PSO.lib.itemInfo(wep)
					
					-- set pos floorsprite
					
					-- for interpolation.
					local prevswordpos = {
						pos[2],
						pos[3],
						pos[4],
						pos[6],	-- rollangle
					}
					
					if timer == 1
						
						mo.momx = $/2
						mo.momy = $/2
						mo.momz = FRACUNIT*10
						mo.state = S_PLAY_SPRING
						mo.groundtimer = nil
						
					end
					
					if timer >= 1
					and timer < slamtime
						mo.momz = max(0, $)
					elseif timer == slamtime
						mo.momz = -FRACUNIT*20
						mo.state = S_PLAY_FALL
						mo.momx = 0
						mo.momy = 0
					end
					
					if timer >= TICRATE/4
						if timer < slamtime
						and mo.state ~= S_PLAY_ROLL
							mo.state = S_PLAY_ROLL
						end
						
						local h_an = p.drawangle
						local v_an = min(TICRATE-10, (timer - TICRATE/4)) *ANG1*32
						local dist = 64
						
						local posa = FixedMul(mo.scale, sin(v_an)*dist)
						local tx = FixedMul(cos(h_an), posa)
						local ty = FixedMul(sin(h_an), posa)
						local tz = mo.height/2 + FixedMul(mo.scale, dist*cos(v_an))
						
						pos[2] = tx
						pos[3] = ty
						pos[4] = tz
						pos[5] = ANG1*5
						pos[6] = -(v_an - ANG1*90)
						
						sword_trail(mo, pos, prevswordpos)
					end
					
					if timer == TICRATE/4 *2
					or timer == TICRATE/4 *3
						-- spawn a hitbox in front of and another behind the player
						local hpotency = potency/4	-- 1/4th of the damage
						
						local ang = p.drawangle
						for i = 1, 2
							
							local x = mo.x + 96*cos(ang)
							local y = mo.y + 96*sin(ang)							
							local hb = PSO.lib.spawnHurtBox(x, y, mo.z-FRACUNIT*128, 140<<FRACBITS, 384<<FRACBITS, mo, hpotency, DMT_STRIKE, 3)
							hb.pso.combobreaker = true
							hb.pso.locks = 1
							
							ang = $ + ANG1*180
						end	
					end
					
					if timer > slamtime
						if P_IsObjectOnGround(mo)
						and not mo.groundtimer
							mo.groundtimer = timer
							S_StartSound(mo, sfx_pstop)
							
							local x = mo.x + 96*cos(p.drawangle)
							local y = mo.y + 96*sin(p.drawangle)
							local hb = PSO.lib.spawnHurtBox(x, y, mo.z - FRACUNIT*32, 140<<FRACBITS, 384<<FRACBITS, mo, potency/2, DMT_STRIKE, 3)
							hb.pso.combobreaker = true
							hb.pso.locks = 2
							
							local da = p.drawangle - ANG1*45
							for i = 1, 4
								local d = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SPINDUST)
								P_InstaThrust(d, da, FRACUNIT*24)
								
								da = $ + (90/4)*ANG1
							end
						end
						
						if mo.groundtimer
						and timer == mo.groundtimer + TICRATE/4
							mo.groundtimer = nil
							return true
						end
					end
					
					--P_SpawnMobj(mo.x+pos[2], mo.y+pos[3], mo.z+pos[4], MT_THOK)
						
				end,
}

-- extend cutter slash
freeslot("MT_SWORDEXTENDCUTTER", "S_EXTENDCUTTER", "SPR_SWSL")
mobjinfo[MT_SWORDEXTENDCUTTER] = {
	doomednum = -1,
	spawnstate = S_EXTENDCUTTER,
	deathstate = S_NULL,
	xdeathstate = S_NULL,
	radius = 5<<FRACBITS,
	height = 10<<FRACBITS,
	flags = MF_MISSILE|MF_NOGRAVITY|MF_RUNSPAWNFUNC,
}

-- disable collision for barta
addHook("MobjCollide", function(mo1, mo2) return false end, MT_SWORDEXTENDCUTTER)
addHook("MobjMoveCollide", function(mo1, mo2) return false end, MT_SWORDEXTENDCUTTER)

function A_ExtendCutter(mo)

	if not mo.pso return end

	local trail = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
	P_CreateFloorSpriteSlope(trail)
					
	trail.flags2 = $ | MF2_SPLAT
	trail.renderflags = $|RF_FLOORSPRITE|RF_SLOPESPLAT|RF_NOSPLATBILLBOARD
					
	trail.sprite = mo.sprite
	trail.frame = A|TR_TRANS30
	trail.tics = 10
	trail.fuse = 10
	trail.floorspriteslope.o = {x=mo.floorspriteslope.o.x, y=mo.floorspriteslope.o.y, z=mo.floorspriteslope.o.z}
	trail.floorspriteslope.xydirection = mo.floorspriteslope.xydirection
	trail.floorspriteslope.zangle = mo.floorspriteslope.zangle
	trail.rollangle = mo.rollangle
	trail.angle = 0
	trail.color = mo.color
	
	mo.friction = FRACUNIT	-- no slowdown
	if not mo.hurtbox
		mo.hurtbox = PSO.lib.spawnHurtBox(mo.x, mo.y, mo.z, 192<<FRACBITS, 192<<FRACBITS, mo.target, mo.pso.potency, DMT_STRIKE, TICRATE*999)
		mo.hurtbox.pso.combobreaker = true
	else
		mo.hurtbox.fuse = 2
		P_MoveOrigin(mo.hurtbox, mo.x, mo.y, mo.z)
	end
end

states[S_EXTENDCUTTER] = {SPR_SWSL, A|FF_ADD, 1, A_ExtendCutter, 0, 0, S_EXTENDCUTTER}

PSO.info.photonArts["sword_pa_extendcutter"] = {
		name = "Extend Cutter",
		desc = "A powerful slash that generates a short range shockwave to attack enemies barely out of your reach.",
		cost = 20,
		potency = 800,
		speed = 20,		-- speed % multiplier.
						-- 100: full speed
						-- 0: stand still
		
		icon = "H_SWATK3",
		
		use = 	function(p, timer, hold, input, combo)
					
					local mo = p.mo
					-- rifle is always weapon slot 1
					local pos = p.pso.weaponpos[1]
					local potency = PSO.info.photonArts[p.pso.action].potency
					local wep = PSO.lib.getPlayerActiveWeapon(p)
					local winfo = PSO.lib.itemInfo(wep)
					
					-- set pos floorsprite
					
					-- for interpolation.
					local prevswordpos = {
						pos[2],
						pos[3],
						pos[4],
						pos[6],	-- rollangle
					}
					
					pos[7] = {
						use = true,
						o = {x = mo.x, y = mo.y, z = mo.z + mo.height/2},	-- the center of the slope is the center of the player.
						xy = p.drawangle + ANG1*90,	-- tilt sideways
						za = ANG1*40,				-- tilt by 30 degrees
					}
						
					local ang

					if mo.swordangle == nil
						mo.swordangle = 0
					end
						
					if timer < TICRATE*3/4
						mo.swordangle = -ANG1*150
					elseif timer < TICRATE*2
						local nt = timer-TICRATE*3/4
						mo.swordangle = $ + max(0, ANG1*(35 - (nt-2)*4))
					end
						
					local ang = p.drawangle + mo.swordangle
					local x = 64 * cos(ang)
					local y = 64 * sin(ang)
						
					pos[2] = x
					pos[3] = y
					pos[4] = mo.height/2
					pos[5] = 0
					pos[6] = ang + ANG1*90
						
					-- damage box:
					if timer == TICRATE*2/3
						local x = FixedMul(mo.scale, 100*cos(p.drawangle))
						local y = FixedMul(mo.scale, 100*sin(p.drawangle))
							
						--(x, y, z, w, t, source, potency, dtype, duration)
						local trail = PSO.lib.spawnMissile(mo, MT_SWORDEXTENDCUTTER, p.drawangle, 32*FRACUNIT, potency, DMT_STRIKE, x, y, mo.height/2)
						P_CreateFloorSpriteSlope(trail)
										
						trail.flags2 = $ | MF2_SPLAT
						trail.renderflags = $|RF_FLOORSPRITE|RF_SLOPESPLAT|RF_NOSPLATBILLBOARD
						trail.floorspriteslope.o = pos[7].o
						trail.floorspriteslope.xydirection = pos[7].xy
						trail.floorspriteslope.zangle = pos[7].za	
						trail.rollangle = p.drawangle + ANG1*90
						trail.angle = 0
						trail.color = PSO.info.elementColours[wep.element]
						
						P_InstaThrust(trail, p.drawangle, FRACUNIT*32)
						trail.fuse = TICRATE
							
						if winfo.sound
							S_StartSound(mo, winfo.sound)
						end
					end
					
					-- sword trail:
					if timer > 1
						sword_trail(mo, pos, prevswordpos)
					end
						
					if timer == TICRATE*2
						return true
					end
						
					--P_SpawnMobj(mo.x+pos[2], mo.y+pos[3], mo.z+pos[4], MT_THOK)
						
				end,
}
		
PSO.info.photonArts["sword_pa_spiralbreak"] = {
		name = "Spiral Break",
		desc = "Swing in a circular motion before leaping and crashing down in an area of effect.",
		cost = 30,
		potency = 680,
		speed = 0,		-- speed % multiplier.
						-- 100: full speed
						-- 0: stand still
		
		icon = "H_SWATK2",
		
		use = 	function(p, timer, hold, input, combo)
					
					local mo = p.mo
					-- rifle is always weapon slot 1
					local pos = p.pso.weaponpos[1]
					local potency = PSO.info.photonArts[p.pso.action].potency
					local winfo = PSO.lib.itemInfo(PSO.lib.getPlayerActiveWeapon(p))
					
					-- set pos floorsprite
					
					-- for interpolation.
					local prevswordpos = {
						pos[2],
						pos[3],
						pos[4],
						pos[6],	-- rollangle
					}
					
					
					if timer == 1
						mo.initangle = p.drawangle
						mo.state = S_PLAY_FALL
						mo.groundtimer = 0
					end
					
					if timer < TICRATE*3/4
						
						local ang = mo.initangle + timer*ANG1*30
						p.drawangle = ang
						
						local sx = 32*cos(ang)
						local sy = 32*sin(ang)

						pos[7] = {
							use = true,
							o = {x = mo.x, y = mo.y, z = mo.z + mo.height/2},	-- the center of the slope is the center of the player.
							xy = mo.initangle + ANG1*45,
							za = min(ANG1*45, timer*ANG1*2),
						}
						
						pos[2] = sx
						pos[3] = sy
						pos[4] = mo.height/2
						pos[5] = 0
						pos[6] = ang + ANG1*40						
						
						local momz = (TICRATE*3/4 - timer)*mo.scale / 6
						mo.momz = momz
						
						if timer == 4
						or timer == 17
							local hb = PSO.lib.spawnHurtBox(mo.x, mo.y, mo.z, 320<<FRACBITS, 40<<FRACBITS, mo, potency/5, DMT_STRIKE, 8)
							hb.pso.combobreaker = true
							hb.pso.locks = 4
							if winfo.sound
								S_StartSound(mo, winfo.sound)
							end
						end
						
					elseif timer >= TICRATE*3/4
						
						if timer == TICRATE*3/4
							mo.momz = mo.scale*48
							S_StartSound(mo, sfx_zoom)
						end
						
						mo.momz = $ - mo.scale*6
						
						pos[7] = {
							use = false,
							o = {x = mo.x, y = mo.y, z = mo.z + mo.height/2},	-- the center of the slope is the center of the player.
							xy = 0,
							za = 0,
						}
						
						pos[2] = 0
						pos[3] = 0
						pos[4] = 0
						pos[5] = ANG1*90
						pos[6] = -ANG1*90
						
						if P_IsObjectOnGround(mo)
							if not mo.groundtimer
								mo.groundtimer = timer
								local hb = PSO.lib.spawnHurtBox(mo.x, mo.y, mo.z - mo.scale*32, 320<<FRACBITS, 40<<FRACBITS, mo, potency*3/5, DMT_STRIKE, 8, RT_BLOWDOWN)
								hb.pso.combobreaker = true
								hb.pso.reactionradialangle = true
								S_StartSound(mo, sfx_pstop)
								
								for i = 1, 8
									local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SPINDUST)
									s.angle = 360/8 *i *ANG1
									P_InstaThrust(s, s.angle, FRACUNIT*24)
								end
							end
						end
						
						if mo.groundtimer
						and timer > mo.groundtimer + TICRATE/2
							return true
						end
					end	

					if timer > 1
					and timer < TICRATE*3/4
						sword_trail(mo, pos, prevswordpos)
					end
					
				end,
}
