local starttime = TICRATE/2
local maxscale = TICRATE*3/4

local function playerQuestFinishHUD(v, p)

	local gradenames = {
		[QG_TIME] = "CLEAR TIME",
		[QG_KILLS] = "KILLS",
		[QG_NOINCAP] = "NO INCAPACITATION",
		[QG_DAMAGETAKEN] = "DAMAGE TAKEN",
	}
	
	if p.pso.quest and p.pso.quest.completetimer
		
		local w = 220
		local h = 130
		local ypos = 10 +3
		local xpos = 160 - w/2
		
		
		v.drawFill(xpos, 10, w, h, 253)
		
		
		v.drawString(160, ypos, "QUEST CLEAR", V_YELLOWMAP, "center")
		
		ypos = $+12
		
		-- check all the shit:
		if server.questdata
			local q = PSO.info.quests[server.questdata.map][server.questdata.index]
			if q.grading
				for i = 1, #q.grading
					
					
					local g = q.grading[i]
					local gtype = g[1]
					
					-- get the name
					local name = gradenames[gtype]
					if gtype == QG_KILLS
						if g[4] and PSO.info.enemies[g[4]]
							name = PSO.info.enemies[g[4]].name.." "..gradenames[gtype]
						else
							name = "ENEMY "..gradenames[gtype]
						end
					end
					
					v.drawString(xpos+4, ypos, name..":", V_YELLOWMAP)
					
					
					-- get the player's value (grade)
					local val = p.pso.quest.grades[i][1]
					local valscore = 0
					
					if p.pso.quest.completetimer > starttime
						valscore = min(p.pso.quest.grades[i][2] * (p.pso.quest.completetimer - starttime) / maxscale, p.pso.quest.grades[i][2])
					end	
						
					local maxscore = g[2]
					
					if gtype == QG_TIME
						local rawtime = val
						val = G_TicsToMinutes(rawtime)..":"..string.format("%02d", tostring(G_TicsToSeconds(rawtime))).."'"..string.format("%02d", tostring(G_TicsToCentiseconds(rawtime)))
					end
					
					v.drawString(xpos + w - 4, ypos, val, 0, "right")
					v.drawString(xpos + w - 4, ypos+8, valscore.."/"..maxscore, (valscore >= maxscore and V_YELLOWMAP or 0), "right")
					
					ypos = $ + 20
					
					/*
						grading = {
							{QG_TIME, full_point_time, 0_point_time, full_time, low_time},
							{QG_KILLS, max_points, max_kills, [MT_ type]},
							{QG_NOINCAP, points_for_no_incapacitation},
							{QG_DAMAGETAKEN, full_point_damagetaken, 0_point_damagetaken, low_damage_taken, high_damage_taken},
						}
					*/
					
					
				end
				
				ypos = 10 + h - 50
				v.drawFill(xpos+2, ypos - 4, w-3, 2, 28)
				v.drawFill(xpos+2, ypos - 4, w-4, 1, 0)		
				
				if p.pso.quest.completetimer > starttime + maxscale
					
					local t = p.pso.quest.completetimer - starttime - maxscale
					local val = min(p.pso.quest.totals[1], p.pso.quest.totals[1] * t / maxscale)
					
					v.drawString(xpos+4, ypos, string.sub("RANK", 1, t), V_YELLOWMAP)
					v.drawString(xpos+4, ypos+8, val.."/"..p.pso.quest.totals[2], val >= p.pso.quest.totals[2] and V_YELLOWMAP or 0)
					
					-- draw rank icon:
					
					if t > maxscale*3
					
						local rank = p.pso.quest.ranking
						v.draw(xpos+58, ypos, v.cachePatch("H_RANK"..rank))
						
						-- show TP:
						v.drawString(xpos + w - 4, ypos, "TYPE POINTS", V_YELLOWMAP, "right")
						v.drawString(xpos + w - 4, ypos+8, p.pso.quest.typepoints, 0, "right")
					end
				end
			end
		end
	end
end

PSO.lib.registerHudFunc(playerQuestFinishHUD)