-- Used when the player asks to be healed!

local choices = {
		"Use Scape Doll",
		"Teleport to medbay",
}

local choices_noreturn = {
		"Use Scape Doll",
		"Abandon Quest",
}

local function isEveryoneDead()
	local count = 0
	local dead = 0
	
	for p in players.iterate do
		if p.mo and p.mo.valid and p.pso
			count = $+1
			if p.pso.hp <= 0
				dead = $+1
			end
		end
	end
	
	return dead >= count
end

local function drawIncapacitationMenu(v, p, c, choice, timer)
	
	if not server.questdata return end
	
	local w = 175
	local h = server.questdata.noreturn and 60 or 40
	
	local x = 160-(w/2)
	local y = 100-(h/2)
	local t = server.questdata.noreturn and choices_noreturn or choices
	
	if not server.questdata return end
	
	v.drawFill(x, y, w, h, 253)
	
	v.drawString(160, y+4, "INCAPACITATED...", V_YELLOWMAP, "center")
	if server.questdata.noreturn
		v.drawString(160, y+15, "The leader may abandon the quest", V_YELLOWMAP, "thin-center")
		v.drawString(160, y+23, "when all players are incapacitated.", V_YELLOWMAP, "thin-center")
	end
	
	local cy = y+(server.questdata.noreturn and 38 or 16)
	for i = 1, #t
		
		local tflag = 0
		if i == 1 and not PSO.lib.findPlayerItem(p, "scape doll")
		or ((i == 2 and server.questdata.noreturn) and (p ~= PSO.lib.getLeader() or not isEveryoneDead()))
			tflag = V_50TRANS
		end
		
		v.drawString(160, cy, (i == choice and "\x82"..">" or "")..t[i], tflag, "center")
		cy = $+10
	end
end

PSO.info.menus["skillissue"] = {
	
	hudfunc = function(v, p, c, choices, choice, timer)
		drawIncapacitationMenu(v, p, c, choice, timer)
	end,
	
	runfunc = function(p)
		local input = PSO.lib.playerInputDown
		
		p.pso.hp = 0	-- you STAY dead.
		
		if not server.questdata
			PSO.lib.revivePlayer(p, p, p.pso.maxhp)
			return true
		end
		
		if input(p, IPT_CONFIRM) == 1
			
			if p.pso.menu.choice == 1
				
				local index = PSO.lib.findPlayerItem(p, "scape doll")
				if not index
					S_StartSound(nil, sfx_mnot, p)
					return
				else
					-- use the scape doll up
					PSO.lib.playerLoseItem(p, index)
				end
				
				S_StartSound(nil, sfx_mconf, p)
				PSO.lib.revivePlayer(p, p, p.pso.maxhp)
			else
				
				-- abandon quest (leader only)
				if server.questdata.noreturn
					
					if not isEveryoneDead()
					or p ~= PSO.lib.getLeader()
						S_StartSound(nil, sfx_mnot, p)
						return true
					end
					
					server.questdata.failed = 1
					
					for p2 in players.iterate
						if p2 and p2.mo and p2.mo.valid
							PSO.lib.closeMenu(p2)
							PSO.lib.playerNotification(p2, "\x82".."QUEST FAILED...")
						end
					end
				else	-- return to medbay
					
					PSO.lib.revivePlayer(p, p, p.pso.maxhp)
					-- prep tp to destination 2:				
					-- find the target
					local target
					for m in mobjs.iterate() do
						if m and m.valid and m.type == MT_PSO_TELEPORT_DEST and m.mtangle == 2
							target = m
							break
						end
					end
					
					if target and target.valid
						PSO.lib.softResetPlayer(p)
						p.pso.teleport = 1
						p.pso.teleporttarget = target
						p.pso.teleporttype = 1
					else
						print("\x82".."WARNING: ".."\x80"..": Missing teleporter destination with angle 2 at medbay for players")
					end

					--p.pso.incapacitations = $ and $+1 or 1
					if p.pso.quest
						p.pso.quest.incapacitations = $+1
					end
					p.pso.usecheckpoint = true
					S_StartSound(nil, sfx_mconf, p)
				end
			end
		end
	end,
	
	choices = choices,
}