-- Contains a function to draw the inventory because it's pretty messy.
-- This is used by the inventory & the storage

PSO.lib.navigateInventoryTabs = function(p, where)
	local input = PSO.lib.playerInputDown
	local maxs = 3	-- 3 sections in the inventory
	local tab = where.."section"
	local sections = where.."_sections"
	
	p.pso[tab] = $ or 0
	
	if input(p, "right") == 1
		p.pso[tab] = $+1
			
		if p.pso[tab] > maxs
			p.pso[tab] = 1
		end

		-- update bounds
		p.pso.menu.minchoice = p.pso[sections][p.pso[tab]]
		p.pso.menu.maxchoice = max(p.pso.menu.minchoice, p.pso[sections][p.pso[tab]+1] -1)
			
		p.pso.menu.choice = p.pso.menu.minchoice
		p.pso.menu.scroll = 0
		S_StartSound(nil, sfx_mhvr, p)
			
		return true
	elseif input(p, "left") == 1
		p.pso[tab] = $-1
			
		if not p.pso[tab]
			p.pso[tab] = maxs
		end
			
		-- update bounds
		p.pso.menu.minchoice = p.pso[sections][p.pso[tab]]
		p.pso.menu.maxchoice = max(p.pso.menu.minchoice, p.pso[sections][p.pso[tab]+1] -1)
			
		p.pso.menu.choice = p.pso.menu.minchoice
		p.pso.menu.scroll = 0
		S_StartSound(nil, sfx_mhvr, p)
			
		return true
	end
	return false
end

-- draws an inventory at the default coords
-- if we shop, display prices as well
-- (1 for buying, 2 for selling, so reduced price)
PSO.lib.HUDDrawInventory = function(v, p, where, tab, index, scroll, shoptype, storage)
	local xpos = 2
	local w = 178
	v.drawFill(xpos, 20, w, 90, 253|V_SNAPTOLEFT)
		
	-- draw all items!
	local inv = p.pso[where]
	
	local sect = where.."_sections"
	local start = p.pso[sect][tab] + scroll
	local finish = p.pso[sect][tab+1] or #p.pso[where]
		
	local y = 34
		
	v.drawFill(xpos+2, 31, w-4, 2, 27|V_SNAPTOLEFT)
	v.drawFill(xpos+2, 31, w-5, 1, 0|V_SNAPTOLEFT)
		
	local sx = xpos + 14
	for i = 1, 3
		v.draw(sx, 21, v.cachePatch("H_ITAB"..i..(tab == i and "2" or "")), V_SNAPTOLEFT)
		sx = $ + 14
	end

	if start ~= finish
		for i = start, min(start + 6, finish-1)
			-- inv[i][1] = item ref / userdata (if wep/armor)
			-- inv[i][2] = quantity (if applicable)
				
			local it = inv[i][1]
			local qty = inv[i][2]
			local xoffs = 0
			local info
			local tflag = 0	
				
			if type(it) == "string"	-- item is a direct reference
				info = PSO.info.items[it]
				xoffs = -20
			else	-- userdata
				info = PSO.info.items[it.ref]
					
				if it.equipped
					v.draw(xpos+2, y, v.cachePatch("H_EQ"), V_SNAPTOLEFT)
				elseif not PSO.lib.canEquip(p, it)
					tflag = V_50TRANS
					v.draw(xpos+2, y, v.cachePatch("H_NEQ"), V_SNAPTOLEFT)
				end
					
				if it.type == IT_WEAPON
				or it.type == IT_ARMOR
				or it.type == IT_UNIT
					-- for equipment restriction..
					if it.type == IT_WEAPON
						xoffs = $+9
					end
							
					local pname = "H_STAR"..((it.rarity-1)/3 +1)
					v.draw(xpos+2+10, y, v.cachePatch(pname), V_SNAPTOLEFT)
				end
			end
				
			local itname = PSO.lib.getItemName(it)
			local ico = PSO.lib.getItemIcon(it)
			local sel = i == index
				
			v.draw(xpos+22+xoffs, y, v.cachePatch(ico..(sel and "2" or "")), V_SNAPTOLEFT|tflag)
				
			if info.type >= IT_CONSUMABLE
			and not shoptype
				local qtylimit = info.carrylimit
					
				local qstr = (sel and "\x82" or "").."x"..qty..((not storage and qtylimit) and ("/"..qtylimit) or "")
				v.drawString(xpos + w - 2, y, qstr, V_ALLOWLOWERCASE|V_SNAPTOLEFT, "right")
		
			elseif shoptype
				
				local price = PSO.lib.itemPrice(it)
				if shoptype == 2
					price = max(1, $/8)
				end
				
				-- add the quantity to the name directly
				if info.type >= IT_CONSUMABLE
					itname = $.." ("..qty..")"
				end

				-- draw amount of meseta
				v.draw(xpos + w - 12, y-1, v.cachePatch("H_MST"), V_SNAPTOLEFT)
				v.drawString(xpos + w - 14, y, (sel and "\x82" or "")..PSO.lib.numCommas(price), V_SNAPTOLEFT, "thin-right")				
			end
			
			-- item name
			v.drawString(xpos + 32+xoffs, y, (sel and "\x82" or "")..itname, V_SNAPTOLEFT|V_ALLOWLOWERCASE|tflag)
				
			y = $+10
		end
	end
		
	local y2 = 114
	v.drawFill(xpos, y2, w, 82, 253|V_SNAPTOLEFT)
		
		
	local slot = p.pso[where][index]
	local selected
	local info
		
	if slot and start ~= finish
		selected = slot[1]
		if type(selected) == "string"
			info = PSO.info.items[selected]
		else
			info = PSO.info.items[selected.ref]
		end
			
		--v.drawString(xpos+2, 130, desc, V_ALLOWLOWERCASE|V_SNAPTOLEFT, "thin")
			
		-- display specific info based on what item we're selecting:
		if info.type == IT_WEAPON
				
			local atk = string.format("%03d", selected.atk)
			local elm = string.format("%02d", (selected.elementv or 0))
				
			v.drawString(xpos+2, y2+2, "\x82".."ATK: \x80"..atk.."\x82".." /", V_SNAPTOLEFT)
				
			if elm
				v.draw(xpos+73, y2+3, v.cachePatch("H_ELEM"..selected.element), V_SNAPTOLEFT)
				v.drawString(xpos+80, y2+2, elm.."%", V_SNAPTOLEFT)
			end
			
			local canequip, reason = PSO.lib.canEquip(p, selected)
			
			if canequip
				v.drawString(xpos+2, y2+12, "\x82".."EQUIP LV: \x80"..(info.req or 1), V_SNAPTOLEFT)
			else
				local s = ""
				if reason == 1	-- level
					s = "LV ("..p.pso.level.."/"..(info.req or 1)..")"
				else
					s = "PROFICIENCY"
				end
				
				v.drawString(xpos+2, y2+12, "\x85".."CAN'T EQUIP: "..s, V_SNAPTOLEFT)
			end
				
			-- get the cost/power
			local cost = 100
			local cost_col = "\x80"
				
			local power = 100
			local power_col = "\x80"
				
			if selected.pa_cost
				cost = selected.pa_cost
				if cost < 100
					cost_col = "\x85"
				elseif cost > 100
					cost_col = "\x84"
				end
			end
			if selected.pa_damage
				power = selected.pa_damage
				if cost > 100
					power_col = "\x85"
				elseif cost < 100
					power_col = "\x84"
				end					
			end
				
			v.drawString(xpos+2, y2+22, "\x82".."ARTS (CST:"..cost_col..cost.."% \x82".."POW:"..power_col..power.."%\x82"..")", V_SNAPTOLEFT)
				
			local ay = y2+34
			local hand = PSO.info.weaponHand[selected.weapontype]
			
			for i = 1, (hand == HAND_BOTH and 4 or 2)
					
				local bt = PSO.lib.playerButtonIcon(p, IPT_ATTACK + (i-1)%2, true)
				local dta = PSO.info.photonArts[selected.actions[i]]
				local ico
				local str = "---"
					
				if dta
					ico = v.cachePatch(dta.icon)
					str = dta.name
				else
					
				end
					
				if ico
					v.draw(xpos + 64 - 13, ay-3, ico, V_SNAPTOLEFT)
				end
				v.drawString(xpos + 64, ay, str, V_ALLOWLOWERCASE|V_SNAPTOLEFT, "thin")
					
				v.draw(xpos + 32, ay-3, v.cachePatch(bt), V_SNAPTOLEFT)
				if i > 2
					local bt2 = PSO.lib.playerButtonIcon(p, IPT_SECONDPALETTE, true)
					v.draw(xpos + 8, ay-3, v.cachePatch(bt2), V_SNAPTOLEFT)
					v.drawString(xpos + 25, ay-1, "+", V_ALLOWLOWERCASE|V_SNAPTOLEFT)
				end
					
				ay = $+12
			end
				
		elseif info.type == IT_ARMOR
			local def = string.format("%03d", selected.def or 0)
			local elm = string.format("%02d", (selected.elementv or 0))
				
			v.drawString(xpos+2, y2+2, "\x82".."DEF: \x80"..def.."\x82".." /", V_SNAPTOLEFT)
				
			if elm
				v.draw(xpos+73, y2+3, v.cachePatch("H_ELEM"..selected.element), V_SNAPTOLEFT)
				v.drawString(xpos+80, y2+2, elm.."%", V_SNAPTOLEFT)
			end
			
			local canequip, reason = PSO.lib.canEquip(p, selected)
			if canequip
			
				v.drawString(xpos+2, y2+12, "\x82".."EQUIP LV: \x80"..(info.req or 1), V_SNAPTOLEFT)
			else
				-- armours don't have proficiency
				local s = "LV ("..p.pso.level.."/"..(info.req or 1)..")"
				v.drawString(xpos+2, y2+12, "\x85".."CAN'T EQUIP: "..s, V_SNAPTOLEFT)
			end
			
			if info.slots
				v.drawString(xpos+2, y2+22, "\x82".."UNIT SLOTS: \x80", V_SNAPTOLEFT)
					
				local ay = y2+34
				for i = 1, info.slots or 0
					local str = "---"
					
					if selected.slots and selected.slots[i]
						str = selected.slots[i].name
					end
					
					v.drawString(xpos+2, ay, str, V_ALLOWLOWERCASE|V_SNAPTOLEFT)
					ay = $+10
				end
			else
				v.drawString(xpos+2, y2+22, "\x82".."NO UNIT SLOTS \x80", V_SNAPTOLEFT)
			end

		elseif info.type == IT_UNIT
			local stats = {"hp", "pp", "satk", "ratk", "tatk", "ppregen"}
			local statnames = {"HP", "PP", "S-ATK", "R-ATK", "T-ATK", "PP REGEN"}
			
			for i = 1, #stats
				
				v.drawString(xpos+2, y2+2+(i-1)*8, "\x82"..statnames[i]..":", V_SNAPTOLEFT)
				
				local stat = info[stats[i]]
				local str = ""
				
				if stat > 0
					str = "\x85".."+"..stat
				elseif stat < 0
					str = "\x84".."-"..stat
				else
					str = stat
				end
				
				v.drawString(xpos+2 + 85, y2+2+(i-1)*8, str, V_SNAPTOLEFT)
			end
				
		else

			local desc = PSO.lib.wordWrap(v, info.desc or "", w-8, V_ALLOWLOWERCASE, "thin")
			v.drawString(xpos + 2, y2+2, desc, V_ALLOWLOWERCASE|V_SNAPTOLEFT, "thin")
				
			PSO.lib.HUD_drawItemRarity(v, xpos+2, y2+70, V_SNAPTOLEFT, info.rarity or 0)	
		end
			
		if info.type and info.type < IT_CONSUMABLE
			-- draw desc + rarity:
			local w2 = 320 - xpos - w - 2
			v.drawFill(xpos+w, y2, w2, 82, 253|V_SNAPTOLEFT)
				
			v.drawFill(xpos+w -1, y2+1, 2, 80, 27|V_SNAPTOLEFT)
			v.drawFill(xpos+w -1, y2+1, 1, 79, 0|V_SNAPTOLEFT)
				
			local desc = PSO.lib.wordWrap(v, info.desc or "", w2-8, V_ALLOWLOWERCASE, "thin")
			v.drawString(xpos + w + 2, y2+2, desc, V_ALLOWLOWERCASE|V_SNAPTOLEFT, "thin")
				
			PSO.lib.HUD_drawItemRarity(v, xpos+w+2, y2+70, V_SNAPTOLEFT, info.rarity or 0)	
		end	
	end
end