-- settings related menus

PSO.info.menus["status"] = {
	
	hudfunc = function(v, p, c, choices, choice, timer)
		drawMainMenu(v, p, c, 2, 999)

		local xpos = 2
		local w = 128
		local y = 20
		local h = 32
		
		v.drawFill(xpos, y, w, h, 253|V_SNAPTOLEFT)
		
		for i = 1, #choices
			
			v.drawString(xpos + 2, y+4, (i == choice and "\x82"..">" or "")..choices[i][1], V_SNAPTOLEFT)
			y = $ + 8
		end
	end,
	
	runfunc = function(p)
		local input = PSO.lib.playerInputDown
		
		if input(p, IPT_BACK) == 1
			
			PSO.lib.changeMenu(p, "main", true, true)
			p.pso.menu.timer = TICRATE*10	-- cheat.
			p.pso.menu.choice = 2
			S_StartSound(nil, sfx_mback, p)
		
		end
	end,
	
	choices = {
		
		{"STATS", "status_stats"},
		{"PHOTON ARTS", "status_pa"},
		{"TYPES", "status_types"},
	},
}


PSO.info.menus["status_types"] = {
	
	hudfunc = function(v, p, c, choices, choice, timer)
		drawMainMenu(v, p, c, 2, 999)

		local xpos = 2
		local w = 96
		local y = 20
		local h = 32
		
		v.drawFill(xpos, y, w, h, 253|V_SNAPTOLEFT)
		
		for i = 1, #choices
			
			v.drawString(xpos + 2, y+4, (i == choice and "\x82"..">" or "")..choices[i][1], V_SNAPTOLEFT)
			y = $ + 8
		end
	
		-- draw proficiency
		local profx = xpos+w+2
		local profy = 20
		local nw = 320 - 4 - xpos - w
		local profh = 60
		
		local chart = p.pso.weaponproficiencies[choice]
		local i = 0
			
		v.drawFill(profx, profy, nw, profh, 253|V_SNAPTOLEFT)
		v.drawString(profx+2, profy, "TYPE WEAPON PROFICIENCY", V_YELLOWMAP|V_SNAPTOLEFT)
			
		local wy = profy + 4 + 8
		while chart[2^i] ~= nil
			local xoffs = (i/5)*48
			local ico = "H_WICO"..PSO.info.weaponnums[2^i]
			v.draw(profx + 12 + xoffs, wy, v.cachePatch(ico), V_SNAPTOLEFT)
				
			local plevel = "H_STAR"..chart[2^i]
			v.draw(profx + 24 + xoffs, wy, v.cachePatch(plevel), V_SNAPTOLEFT)
				
			wy = $ + 10
			i = $+1
				
			if i%5 == 0
				wy = profy + 4 + 8
			end
		end
		
		-- draw skills
		local skillx = profx
		local skilly = profy + profh + 2
		local skillh = 60
		
		v.drawFill(skillx, skilly, nw, skillh, 253|V_SNAPTOLEFT)
		v.drawString(skillx+2, skilly, "TYPE SKILLS", V_YELLOWMAP|V_SNAPTOLEFT)
		
		for i = 1, #p.pso.typeskills[choice]
			local s = p.pso.typeskills[choice][i]
			local skill = PSO.info.typeSkills[s]
			
			v.drawString(skillx+2, skilly+10+(i-1)*8, skill.name, V_SNAPTOLEFT|V_ALLOWLOWERCASE)
		end
		
	end,
	
	runfunc = function(p)
		local input = PSO.lib.playerInputDown
		
		if input(p, IPT_BACK) == 1
			
			PSO.lib.changeMenu(p, "status", true, true)
			p.pso.menu.timer = TICRATE*10	-- cheat.
			p.pso.menu.choice = 3
			S_StartSound(nil, sfx_mback, p)
		
		elseif input(p, IPT_CONFIRM) == 1
			-- don't confirm
			return true
		end
	end,
	
	choices = {
		{"Hunter"},
		{"Ranger"},
		{"Force"},
	},
}

PSO.info.menus["status_pa"] = {
	
	openfunc = function(p)
		
		local palist = {}
		
		for i = 0, 31
			local wpt = 2^i
			if p.pso.photonarts[wpt]
			and PSO.info.weaponPhotonArts[wpt]

				for j = 1, #PSO.info.weaponPhotonArts[wpt]
					if p.pso.photonarts[wpt] & 2^(j-1)
						local pa = PSO.info.photonArts[PSO.info.weaponPhotonArts[wpt][j]]
						
						-- don't show normals
						if pa and pa.cost and not pa.normal
							palist[#palist+1] = PSO.info.weaponPhotonArts[wpt][j]
						end
						--print(PSO.info.weaponPhotonArts[wpt][j])
					end
				end
			end
		end	
		
	
		for i = 1, #PSO.info.weaponPhotonArts.techniques
			if p.pso.photonarts.techniques & 2^(i-1)
				palist[#palist+1] = PSO.info.weaponPhotonArts.techniques[i]
			end			
		end
		
		p.pso.menu.minchoice = 1
		p.pso.menu.maxchoice = #palist
		p.pso.menu.choices = palist
	end,
	
	hudfunc = function(v, p, c, choices, choice, timer)
		drawMainMenu(v, p, c, 2, 999)

		local xpos = 2
		local w = 160
		local y = 20
		local h = 130
		
		v.drawFill(xpos, y, w, h, 253|V_SNAPTOLEFT)
		v.drawString(xpos+2, y+2, "PHOTON ARTS", V_YELLOWMAP|V_SNAPTOLEFT)

		for i = p.pso.menu.scroll+1, min(p.pso.menu.scroll+9, #p.pso.menu.choices)
			local pa = PSO.info.photonArts[p.pso.menu.choices[i]]
			
			if pa
				v.draw(xpos+2, y+12, v.cachePatch(pa.icon), V_SNAPTOLEFT)
				v.drawString(xpos + 16, y+14, (i == choice and "\x82"..">" or "")..pa.name, V_SNAPTOLEFT|V_ALLOWLOWERCASE)
				y = $ + 12
				
				if i == choice
					
					local w2 = (318 - (xpos + w + 2))
					v.drawFill(xpos + w + 2, 20, w2, 64, 253|V_SNAPTOLEFT)
					
					local art = pa
					local pow = (art.potency or "---").."%"
					local cost = (art.cost or 0).." PP"
						
					v.drawString(xpos + w + 4, 20+2, "\x82".."POTENCY: \x80"..pow.."\x82\n".."COST: \x80"..cost, V_RETURN8|V_SNAPTOLEFT)
					
					local desc = PSO.lib.wordWrap(v, art.desc or "", w2-8, V_ALLOWLOWERCASE, "thin")
					v.drawString(xpos + w + 4, 20+20, desc, V_ALLOWLOWERCASE|V_SNAPTOLEFT, "thin")				
				end
			end
		end
	end,
	
	runfunc = function(p)
		local input = PSO.lib.playerInputDown
		
		if input(p, IPT_BACK) == 1
			
			PSO.lib.changeMenu(p, "status", true, true)
			p.pso.menu.choice = 2
			p.pso.menu.timer = TICRATE*10	-- cheat.
			S_StartSound(nil, sfx_mback, p)
		
		end
	end,
	
	scroll = 9,
}

PSO.info.menus["status_stats"] = {
	
	hudfunc = function(v, p, c, choices, choice, timer)
		drawMainMenu(v, p, c, 2, 999)

		local xpos = 2
		local w = 160
		local y = 20
		local h = 100
		
		v.drawFill(xpos, y, w, h, 253|V_SNAPTOLEFT)
		
		v.drawString(xpos+2, y+2, PSO.info.typenames[p.pso.type].." LV"..p.pso.level, V_YELLOWMAP|V_SNAPTOLEFT)
		
		if p.pso.level < PSO.info.LEVELCAP
			v.drawString(xpos+2, y+10, "EXP: "..p.pso.exp.."/"..PSO.info.exptable[p.pso.level], V_YELLOWMAP|V_SNAPTOLEFT)
		else
			v.drawString(xpos+2, y+10, "EXP: FULL", V_YELLOWMAP|V_SNAPTOLEFT)
		end
		
		local snamex = xpos+2
		local svalx = xpos+60
		local svalx2 = xpos+100
		
		v.drawString(snamex, y+20, "STAT", V_YELLOWMAP|V_SNAPTOLEFT)
		v.drawString(svalx, y+20, "VAL", V_YELLOWMAP|V_SNAPTOLEFT)
		v.drawString(svalx2, y+20, "(GEAR)", V_YELLOWMAP|V_SNAPTOLEFT)
		
		v.drawFill(xpos+2, y+28, w-4, 1, V_SNAPTOLEFT)

		local stats = PSO.lib.playerPreviewStats(p, p.pso.type, p.pso.level)
		local statrefs = {"maxhp", "maxpp", "satk", "ratk", "tatk", "def"}
		local statnames = {"HP", "PP", "S.ATK", "R.ATK", "T.ATK", "DEF"}
		
		for i = 1, #statrefs
			local ypos = y+30 + 8*(i-1)
			
			v.drawString(snamex, ypos, statnames[i], V_YELLOWMAP|V_SNAPTOLEFT)
			
			v.drawString(svalx, ypos, tostring(stats[statrefs[i]]), V_SNAPTOLEFT)
			
			local addstat = 0
			
			if i >= 3 and i <= 5
				local weapon = PSO.lib.getPlayerActiveWeapon(p)
						
				local dmts = {DMT_STRIKE, DMT_RANGED, DMT_TECHNIQUE}
				
				if weapon
					local wdmt = PSO.info.weaponDamageType[weapon.weapontype]
						
					if wdmt == dmts[i-2]
						addstat = $ + weapon.atk		
					end
				end
			
			elseif i == 6

				local armor = PSO.lib.getPlayerArmor(p)
				
				if armor
					addstat = $ + armor.def
				end
			end
			
			v.drawString(svalx2, ypos, "("..tostring(p.pso[statrefs[i]] + addstat)..")", V_SNAPTOLEFT)
			
		end
	end,
	
	runfunc = function(p)
		local input = PSO.lib.playerInputDown
		
		if input(p, IPT_BACK) == 1
			
			PSO.lib.changeMenu(p, "status", true, true)
			p.pso.menu.timer = TICRATE*10	-- cheat.
			S_StartSound(nil, sfx_mback, p)
		
		end
		return true
	end,
	
	choices = {},
}