local mapnum = 2
table.insert(PSO.info.questmaps, {mapnum})
PSO.info.quests[mapnum] = {}

/*
	quest format:
	{
		>>COSMETIC STUFF
		name: 		quest name
		objective:	description of the objective
		desc: 		description
	
	
		>>ACTUAL GAMEPLAY RELEVANT STUFF
		map:		map number the quest takes place in
					(players will be warped to it as soon as everyone gets to the teleporter)
		
		layout = {}: 	object layout for the map.
						worth noting the object layout CANNOT be changed in the lobby.
		
		unlocks = {{map, quest, [diff]}, {map, quest, [diff]}, ...}:
		finishing this quest unlocks the specified quests # of the specified maps for the specified difficulty
		only works if that quest was marked as locked to begin with
		
		levels = {                                                                    ,..,.,.,.,.,.,..        
			[DIFF_NORMAL] = x,
			[DIFF_HARD] = x,
			[...]
		}: enemy level per difficulty
		
		
		
	}
*/

/*table.insert(PSO.info.quests[mapnum], {
	
	name = "Test quest",
	desc = "Doesn't load object layout, enemy level matches player level",
	objective = "Test your shit",
	
	map = 1,
	
	levels = {
		[DIFF_NORMAL] = 1,
		[DIFF_HARD] = 1,
		[DIFF_VERYHARD] = 1,
		[DIFF_SUPERHARD] = 1,
		[DIFF_EXTREMELYHARD] = 1,
		[DIFF_ULTRAHARD] = 1,
	},
})*/


table.insert(PSO.info.quests[mapnum], {
	
	name = "1-1: Integration sweep",
	desc = "Command wants to send new recruits on a sweep-up operation on the western coast where Badnik activity is low to build combat practice.",
	objective = "Defeat the Badnik command unit",
	
	map = mapnum,
	
	unlocks = {{2, 2}},	-- unlocks 1-2
	
	levels = {
		[DIFF_NORMAL] = 1,
		[DIFF_HARD] = 30,
	},

	grading = {
		{QG_TIME, 20, 0, TICRATE*60*12, TICRATE*60*15},
		{QG_DAMAGETAKEN, 20, 0, 350, 600},
		{QG_NOINCAP, 10},
	},
	
	layout = {
		{MT_PSO_LASERTOWER, 1056, 1280, 4, 0, 0, 0, 2504},
		{0, -5632, -64, 0, 0, 0, 0, 1},
		{6, 608, 4416, 270, 0, 0, 0, 100},
		{7, -2528, 5152, 270, 0, 0, 0, 101},
		{MT_PSO_ROOMANCHOR, -1888, 1504, 0, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 1408, -768, 0, 0, 0, 0, 2500},
		{MT_PSO_LASERTOWER, 96, 1280, 0, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 320, 1280, 1, 0, 0, 0, 2504},
		{MT_PSO_CARDREADER, 32, 1120, 270, 1, 0, 1, 2503},
		{MT_PSO_UNLOCKCARD, 0, 832, 1, 1, 0, 1, 2502},
		{MT_PSO_LASERTOWER, 576, 1280, 2, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 800, 1280, 3, 0, 0, 0, 2504},
		{MT_PSO_CRATE, -4864, 608, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -5376, 576, 315, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 320, 4064, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 768, 4096, 315, 0, 0, 0, 2505},
		{6, -160, 544, 180, 0, 0, 0, 100},
		{6, -96, 192, 180, 0, 0, 0, 100},
		{6, 576, 1088, 270, 0, 0, 1, 100},
		{6, 224, 1088, 270, 0, 0, 1, 100},
		{6, 928, 1088, 270, 0, 0, 1, 100},
		{17, 352, 4256, 90, 0, 0, 0, 111},
		{17, 800, 4256, 90, 0, 0, 0, 111},
		{7, 608, 3488, 90, 0, 0, 1, 101},
		{MT_PSO_UNLOCKCARD, 544, 3904, 1, 1, 0, 1, 2502},
		{MT_PSO_CARDREADER, 128, 4800, 0, 1, 0, 1, 2503},
		{MT_PSO_LASERTOWER, -64, 4864, 15, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -64, 3872, 11, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -64, 4096, 12, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -64, 4352, 13, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -64, 4608, 14, 0, 0, 0, 2504},
		{MT_PSO_ROOMANCHOR, -160, 4928, 1, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 1728, 3232, 1, 0, 0, 0, 2500},
		{6, -2752, 4864, 315, 0, 0, 0, 100},
		{6, -2752, 4608, 0, 0, 0, 0, 100},
		{17, -3136, 4960, 0, 0, 0, 1, 111},
		{17, -3136, 4512, 0, 0, 0, 1, 111},
		{7, -2880, 4704, 0, 0, 0, 1, 101},
		{6, -2848, 5280, 315, 0, 0, 1, 100},
		{MT_PSO_CRATE, -3424, 5312, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -3200, 5312, 0, 0, 0, 0, 2505},
		{MT_PSO_CARDREADER, -2912, 5344, 270, 1, 0, 1, 2503},
		{MT_PSO_UNLOCKCARD, -2528, 4832, 1, 1, 0, 1, 2502},
		{MT_PSO_LASERTOWER, -2016, 5504, 25, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -2976, 5504, 21, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -2752, 5504, 22, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -2496, 5504, 23, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -2240, 5504, 24, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -3552, 5152, 30, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -3328, 5152, 31, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -3104, 5408, 33, 0, 0, 0, 2504},
		{MT_PSO_ROOMANCHOR, -3648, 5568, 2, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -1920, 3808, 2, 0, 0, 0, 2500},
		{MT_PSO_LASERTOWER, -3104, 5152, 32, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -3968, 8480, 40, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -3616, 8480, 41, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -3296, 8480, 42, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -3008, 8480, 43, 0, 0, 0, 2504},
		{7, -3520, 8224, 315, 0, 0, 0, 101},
		{7, -2944, 8224, 315, 0, 0, 0, 101},
		{9, -3104, 8032, 315, 16, 1, 1, 103},
		{17, -3392, 8224, 0, 0, 0, 1, 111},
		{17, -3040, 8224, 0, 0, 0, 1, 111},
		{MT_PSO_UNLOCKCARD, -3232, 8288, 1, 1, 0, 1, 2502},
		{MT_PSO_CARDREADER, -3008, 8416, 270, 1, 0, 1, 2503},
		{MT_PSO_ROOMANCHOR, -4096, 8544, 3, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -1920, 7456, 3, 0, 0, 0, 2500},
		{MT_PSO_LASERTOWER, -2400, 10368, 50, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -1920, 10368, 51, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -1440, 10368, 52, 0, 0, 0, 2504},
		{MT_PSO_CRATE, -1536, 10176, 0, 0, 0, 0, 2505},
		{9, 1184, 9408, 180, 512, 32, 0, 103},
		{9, 1184, 8736, 180, 512, 32, 0, 103},
		{9, 1536, 9120, 180, 512, 32, 1, 103},
		{17, -1312, 9440, 0, 0, 0, 1, 111},
		{17, -1312, 8608, 0, 0, 0, 1, 111},
		{MT_PSO_LASERTOWER, 672, 10176, 60, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 1152, 10176, 61, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 1632, 10176, 62, 0, 0, 0, 2504},
		{MT_PSO_ROOMANCHOR, -1344, 9568, 4, 8832, 552, 0, 2500},
		{MT_PSO_ROOMANCHOR, 2336, 8352, 4, 0, 0, 0, 2500},
		{17, 4352, 10688, 0, 0, 0, 0, 111},
		{17, 4352, 10688, 0, 0, 0, 0, 111},
		{17, 4352, 10368, 0, 0, 0, 0, 111},
		{9, 3392, 10368, 270, 512, 32, 0, 103},
		{9, 3968, 10368, 270, 512, 32, 0, 103},
		{MT_PSO_UNLOCKCARD, 3712, 10688, 1, 0, 0, 0, 2502},
		{MT_PSO_ROOMANCHOR, 3008, 11264, 5, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 5184, 9472, 5, 0, 0, 0, 2500},
		{MT_PSO_LASERTOWER, 1568, 8448, 70, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 1792, 8448, 71, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 2016, 8448, 72, 0, 0, 0, 2504},
		{MT_PSO_CARDREADER, 2112, 8576, 90, 1, 0, 1, 2503},
		{MT_PSO_LASERTOWER, 5056, 7008, 100, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 5056, 6720, 101, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 5056, 6432, 102, 0, 0, 0, 2504},
		{MT_PSO_CARDREADER, 4928, 6944, 180, 0, 0, 1, 2503},
		{MT_PSO_ROOMANCHOR, 3296, 7424, 6, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 5280, 6304, 6, 0, 0, 0, 2500},
		{MT_PSO_CRATE, 3904, 8000, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 3872, 7712, 0, 0, 0, 0, 2505},
		{MT_PSO_UNLOCKCARD, 1760, 9120, 1, 0, 0, 1, 2502},
		{6, 4512, 6880, 180, 0, 0, 0, 100},
		{6, 4512, 6528, 180, 0, 0, 0, 100},
		{7, 4736, 6688, 180, 0, 0, 0, 101},
		{MT_PSO_LASERTOWER, -3552, 3968, 1000, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -3552, 4352, 1001, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -3552, 4704, 1002, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 4352, 11200, 1100, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 4672, 11200, 1101, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 4992, 11200, 1102, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 1152, 736, 2300, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 1152, 256, 2301, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 1152, -192, 2302, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 1152, -576, 2303, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 1152, -896, 2304, 256, 16, 0, 2504},
		{MT_PSO_LASERTOWER, 1152, -1344, 2305, 256, 16, 0, 2504},
		{MT_PSO_LASERTOWER, 1152, -1632, 2306, 256, 16, 0, 2504},
		{MT_PSO_LASERTOWER, 1728, 4256, 2310, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 1728, 4416, 2311, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 1728, 4640, 2312, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 1728, 4832, 2313, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 6176, 4224, 3001, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 6912, 4224, 3002, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 7488, 4224, 3003, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 8000, 4224, 3004, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 8576, 4224, 3005, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 8576, 4608, 3006, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 8576, 5056, 3007, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 8576, 5504, 3008, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 8576, 5888, 3009, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 8576, 6272, 3010, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 8576, 6656, 3011, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 8576, 7040, 3012, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 8576, 7424, 3013, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 8576, 7904, 3014, 0, 0, 0, 2504},
		{MT_PSO_ROOMANCHOR, 6720, 7936, 7, 1, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 8704, 4160, 7, 0, 0, 0, 2500},
		{13, 7680, 6080, 135, 1, 0, 2, 107},
		{MT_PSO_CRATE, 7232, 5824, 0, 1, 0, 2, 2505},
		{MT_PSO_CRATE, 7616, 5824, 0, 1, 0, 2, 2505},
		{MT_PSO_CRATE, 8000, 5824, 0, 1, 0, 2, 2505},
		{MT_PSO_CRATE, 7232, 5440, 0, 1, 0, 2, 2505},
		{MT_PSO_CRATE, 8000, 5440, 0, 1, 0, 2, 2505},
		{MT_PSO_CRATE, 7616, 5440, 0, 1, 0, 2, 2505},
		{MT_PSO_CRATE, 7232, 5056, 0, 1, 0, 2, 2505},
		{MT_PSO_CRATE, 7616, 5056, 0, 1, 0, 2, 2505},
		{MT_PSO_CRATE, 8000, 5056, 0, 1, 0, 2, 2505},
		{7, 7232, 5248, 135, 1, 0, 0, 101},
		{7, 8000, 5248, 135, 1, 0, 0, 101},
		{7, 7616, 7232, 270, 1, 0, 0, 101},
		{17, 6976, 7616, 0, 1, 0, 1, 111},
		{17, 8064, 7616, 0, 1, 0, 1, 111},
		{17, 8000, 4736, 0, 1, 0, 1, 111},
		{17, 7040, 4736, 0, 1, 0, 1, 111},
		{9, 8128, 6016, 180, 513, 32, 1, 103},
		{9, 8128, 6912, 180, 513, 32, 1, 103},
		{MT_PSO_LASERTOWER, -5472, 1024, 4000, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -5056, 1024, 4001, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -4640, 1024, 4002, 0, 0, 0, 2504},
		{MT_PSO_TELEPORTER, -5856, -64, 1, 1, 0, 1, 2510},
		{MT_PSO_TELEPORT_DEST, -5760, -64, 0, 0, 0, 0, 2511},
		{MT_PSO_TELEPORTER, 8288, 5440, 1, 1, 0, 3, 2510},
}
	
})

table.insert(PSO.info.quests[mapnum], {
	
	name = "1-2: Waterfall cleanup",
	desc = "An abnormal amount of Badniks have been sighted near a waterfall to the west. You're tasked with investigating and eliminating them should you find them.",
	objective = "Defeat the enemies at the target location",
	
	map = mapnum,
	
	locked = true,		-- initially locked
	unlocks = {{2, 3}},	-- unlocks 1-3
	
	levels = {
		[DIFF_NORMAL] = 4,
		[DIFF_HARD] = 32,
	},

	grading = {
		{QG_TIME, 25, 0, TICRATE*60*15, TICRATE*60*20},
		{QG_DAMAGETAKEN, 25, 0, 400, 600},
		{QG_NOINCAP, 10},
	},
	
	-- quest specific drops for use in boxes after the last room is cleared.
	-- useful if the last room doesn't contain a boss enemy
	drops = {
		[DIFF_NORMAL] = {
			{"calibur", 0, 0, 1, 50},
			{"burst", 0, 0, 1, 50},
			{"cane", 0, 0, 1, 50},		

			{"gigush", 1, 0, 6, 50},
			{"beam", 0, 0, 6, 50},
			{"baton", 0, 0, 6, 50},			

			{"giga calibur", 0, 0, 2, 50},
			{"burstbeam", 0, 0, 2, 50},
			{"helixen", 0, 0, 2, 50},	
			
			{1000, nil, nil, 1, 5},
			{"dimate", nil, nil, 1, 5},
		},

		[DIFF_HARD] = {
			{"unit_hp_2", 1, 0, 2, 50},
			{"unit_pp_2", 1, 0, 2, 50},
			{"unit_satk_2", 1, 0, 2, 50},
			{"unit_tatk_2", 1, 0, 2, 50},
			{"unit_ratk_2", 1, 0, 2, 50},	

			{"monogrinder", 0, 0, 6, 50},
			{"digrinder", 0, 0, 3, 50},
			{"trigrinder", 0, 0, 1, 50},
			{"scape doll", 0, 0, 1, 50},
			
			{"poss shooter", 0, 0, 1, 100},
			{"command shot", 0, 0, 1, 100},
			
			{2000, nil, nil, 1, 5},
			{"trimate", nil, nil, 1, 5},
		},
		
	},
	
	layout = {
		{0, 7712, 6464, 180, 0, 0, 0, 1},
		{MT_PSO_TELEPORT_DEST, 7840, 6464, 0, 0, 0, 0, 2511},
		{MT_PSO_TELEPORTER, 7968, 6464, 1, 1, 0, 0, 2510},
		{MT_PSO_LASERTOWER, 6304, 5760, 0, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 6816, 5760, 1, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 7264, 5760, 2, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 7840, 5760, 3, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 8544, 5760, 4, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 8544, 6208, 5, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 8544, 6656, 6, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 8544, 7136, 7, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 8544, 7488, 8, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 7968, 7488, 9, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 7456, 7488, 10, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 6912, 7488, 11, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 6336, 7488, 12, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 2016, 8480, 100, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 1792, 8480, 101, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 1568, 8480, 102, 0, 0, 0, 2504},
		{MT_PSO_CRATE, 1664, 8352, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 1888, 8352, 0, 0, 0, 0, 2505},
		{MT_PSO_LASERTOWER, 3936, 9440, 120, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 3712, 9440, 121, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 3488, 9440, 122, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, 3520, 9280, 270, 0, 0, 1, 2503},
		{MT_PSO_ROOMANCHOR, 3232, 7328, 0, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 4448, 9536, 0, 0, 0, 0, 2500},
		{7, 3520, 8960, 270, 0, 0, 0, 101},
		{7, 3872, 8960, 270, 0, 0, 0, 101},
		{6, 3392, 7840, 0, 0, 0, 0, 100},
		{17, 3552, 7424, 90, 0, 0, 1, 111},
		{17, 3840, 7424, 90, 0, 0, 1, 111},
		{9, 3712, 8640, 270, 256, 16, 1, 103},
		{MT_PSO_UNLOCKCARD, 3712, 8800, 1, 0, 0, 1, 2502},
		{MT_PSO_ROOMANCHOR, 4352, 10784, 1, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 5088, 12160, 1, 0, 0, 0, 2500},
		{17, 4512, 12128, 90, 0, 0, 0, 111},
		{17, 4704, 12128, 90, 0, 0, 0, 111},
		{17, 4928, 12128, 90, 0, 0, 0, 111},
		{6, 4704, 11872, 270, 0, 0, 0, 100},
		{MT_PSO_CRATE, 3936, 10720, 0, 0, 0, 0, 2505},
		{MT_PSO_LASERTOWER, 1632, 12128, 130, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 1152, 12128, 131, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 672, 12128, 132, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -1440, 12128, 140, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -1920, 12128, 141, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -2400, 12128, 142, 0, 0, 0, 2504},
		{MT_PSO_ROOMANCHOR, 2272, 12160, 2, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -3104, 13920, 2, 0, 0, 0, 2500},
		{MT_PSO_LASERTOWER, -2976, 12960, 150, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -2976, 13280, 151, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -2976, 13600, 152, 0, 0, 1, 2504},
		{MT_PSO_CRATE, 832, 12320, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 1152, 12320, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 1408, 12320, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -2816, 12320, 0, 0, 0, 0, 2505},
		{9, -416, 13568, 0, 256, 16, 1, 103},
		{9, -416, 12992, 180, 256, 16, 1, 103},
		{6, 896, 12640, 90, 0, 0, 0, 100},
		{17, -1600, 13568, 90, 0, 0, 1, 111},
		{17, -1600, 13088, 90, 0, 0, 1, 111},
		{17, 896, 13568, 90, 0, 0, 1, 111},
		{17, 864, 13056, 90, 0, 0, 1, 111},
		{9, -416, 13280, 0, 256, 16, 0, 103},
		{MT_PSO_UNLOCKCARD, -832, 13280, 1, 0, 0, 1, 2502},
		{MT_PSO_CARDREADER, -2784, 12960, 0, 0, 0, 1, 2503},
		{MT_PSO_ROOMANCHOR, -4416, 14176, 3, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -8896, 12544, 3, 0, 0, 0, 2500},
		{8, -6528, 13664, 0, 0, 0, 0, 102},
		{6, -5856, 13824, 0, 0, 0, 0, 100},
		{6, -5792, 13120, 0, 0, 0, 0, 100},
		{7, -7488, 13792, 0, 0, 0, 1, 101},
		{7, -7456, 13216, 0, 0, 0, 1, 101},
		{MT_PSO_UNLOCKCARD, -8096, 13536, 1, 0, 0, 1, 2502},
		{MT_PSO_LASERTOWER, -8128, 12640, 160, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -8448, 12640, 161, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -8736, 12640, 162, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, -8128, 12768, 90, 0, 0, 1, 2503},
		{MT_PSO_ROOMANCHOR, -8864, 11744, 4, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -4320, 10208, 4, 0, 0, 0, 2500},
		{17, -7616, 11488, 0, 0, 0, 0, 111},
		{17, -7648, 10560, 0, 0, 0, 0, 111},
		{17, -5024, 11072, 0, 0, 0, 0, 111},
		{MT_PSO_CRATE, -4672, 11456, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -4672, 11168, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -4672, 10880, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -4640, 10528, 0, 0, 0, 0, 2505},
		{MT_PSO_ROOMANCHOR, -6784, 10592, 5, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -4832, 9056, 5, 0, 0, 0, 2500},
		{7, -5472, 9792, 135, 0, 0, 0, 101},
		{6, -5728, 9856, 135, 0, 0, 0, 100},
		{6, -5568, 10144, 135, 0, 0, 0, 100},
		{MT_PSO_LASERTOWER, -8736, 9056, 170, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -8736, 9376, 171, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -8736, 9696, 172, 0, 0, 1, 2504},
		{MT_PSO_CRATE, -7904, 4096, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -8000, 4288, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -7680, 4544, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -7872, 4512, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -7712, 4320, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -7680, 3968, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -8192, 4160, 0, 0, 0, 0, 2505},
		{MT_PSO_LASERTOWER, -7520, 3904, 180, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -7520, 4288, 181, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -7520, 4640, 182, 0, 0, 1, 2504},
		{MT_PSO_ROOMANCHOR, -9984, 8416, 6, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -6528, 5472, 6, 0, 0, 0, 2500},
		{17, -8800, 6112, 0, 0, 0, 0, 111},
		{17, -7936, 6144, 0, 0, 0, 0, 111},
		{9, -8192, 6144, 90, 256, 16, 0, 103},
		{7, -8832, 6560, 90, 0, 0, 0, 101},
		{7, -7456, 7264, 180, 0, 0, 0, 101},
		{MT_PSO_UNLOCKCARD, -9408, 6656, 1, 0, 0, 0, 2502},
		{MT_PSO_LASERTOWER, -9824, 6272, 190, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -9824, 5920, 191, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -9824, 5536, 192, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -9376, 5536, 193, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -8992, 5536, 194, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -8928, 6112, 200, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -8928, 5824, 201, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -8928, 5536, 202, 0, 0, 0, 2504},
		{MT_PSO_CARDREADER, -9696, 5760, 90, 0, 0, 1, 2503},
		{MT_PSO_ROOMANCHOR, -14464, 6336, 7, 1, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -10112, 4448, 7, 1, 0, 0, 2500},
		{8, -13152, 5568, 0, 0, 0, 0, 102},
		{8, -12608, 4864, 0, 1024, 64, 0, 102},
		{8, -11936, 5248, 0, 0, 0, 0, 102},
		{6, -12256, 5760, 0, 0, 0, 0, 100},
		{17, -13920, 5376, 0, 0, 0, 1, 111},
		{17, -13856, 4704, 0, 0, 0, 1, 111},
		{9, -13056, 5248, 0, 0, 0, 1, 103},
		{7, -10784, 5280, 180, 0, 0, 1, 101},
		{8, -12672, 5696, 180, 0, 0, 1, 102},
		{8, -11712, 5664, 180, 0, 0, 1, 102},
		{17, -10304, 5952, 180, 0, 0, 2, 111},
		{17, -10432, 5376, 180, 0, 0, 2, 111},
		{17, -10240, 4896, 180, 0, 0, 2, 111},
		{8, -13824, 5856, 180, 0, 0, 2, 102},
		{8, -13664, 5216, 180, 0, 0, 2, 102},
		{8, -13184, 4608, 180, 0, 0, 2, 102},
		{MT_PSO_TELEPORTER, -13952, 4992, 1, 1, 0, 3, 2510},
		{MT_PSO_CRATE, -12640, 5792, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, -12192, 5792, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, -11744, 5792, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, -12640, 5472, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, -12192, 5472, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, -11744, 5472, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, -12640, 5184, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, -12192, 5184, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, -11744, 5184, 0, 5, 0, 2, 2505},
	},

})

table.insert(PSO.info.quests[mapnum], {
	
	name = "1-3: Coastal Caves Tyrant",
	desc = "A strong reading has been detected somewhere inside the coastal caves. It could be dangerous, so prepare yourself before investigating",
	objective = "Investigate the target location",
	
	map = mapnum,

	locked = true,		-- initially locked
	unlocks = {{3, 1}},	-- unlocks 2-1
	
	levels = {
		[DIFF_NORMAL] = 7,
		[DIFF_HARD] = 34,
	},

	grading = {
		{QG_TIME, 35, 0, TICRATE*60*15, TICRATE*60*20},
		{QG_DAMAGETAKEN, 25, 0, 400, 600},
		{QG_NOINCAP, 10},
	},
	
	layout = {
		{0, 6560, 0, 90, 0, 0, 0, 1},
		{MT_PSO_SNAPPERBOSS, -12224, 13472, 270, 1, 0, 0, 2550},
		{MT_PSO_ROOMANCHOR, 1984, 3008, 0, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 7840, 576, 0, 0, 0, 0, 2500},
		{MT_PSO_LASERTOWER, 2064, 768, 0, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 2400, 768, 1, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 2784, 768, 2, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 3168, 768, 3, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 3552, 768, 4, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 3552, 480, 5, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 3552, 192, 6, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 3552, -160, 7, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 3552, -480, 8, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 3552, -960, 9, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 4032, -960, 10, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 4512, -960, 11, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 4960, -960, 12, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 5408, -960, 13, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 5824, -960, 14, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 6336, -960, 15, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 6880, -960, 16, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 7296, -960, 17, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 7744, -960, 18, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 7744, -608, 19, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 7744, -224, 20, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 7744, 160, 21, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 7744, 512, 22, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 7744, 864, 23, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 7744, 1152, 24, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 7744, 1440, 25, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 7744, 1760, 26, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 7744, 2080, 27, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 7744, 2464, 28, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 7744, 2848, 29, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 7360, 2848, 30, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 6944, 2848, 31, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 6592, 2848, 32, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 6272, 2848, 33, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 6272, 2912, 34, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 4288, 2912, 100, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 4864, 2912, 101, 0, 0, 1, 2504},
		{6, 3712, 1440, 315, 0, 0, 0, 100},
		{6, 4864, 1792, 270, 0, 0, 0, 100},
		{6, 5952, 1728, 270, 0, 0, 0, 100},
		{8, 4576, 1024, 0, 0, 0, 1, 102},
		{8, 5728, 1216, 0, 0, 0, 1, 102},
		{7, 4512, 1920, 270, 0, 0, 1, 101},
		{7, 5568, 2048, 270, 0, 0, 1, 101},
		{17, 3200, 1600, 0, 0, 0, 2, 111},
		{17, 4608, 2464, 0, 0, 0, 2, 111},
		{17, 6784, 1920, 0, 0, 0, 2, 111},
		{7, 3776, 2240, 315, 0, 0, 2, 101},
		{7, 5920, 2336, 270, 0, 0, 2, 101},
		{MT_PSO_CRATE, 7584, 2688, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 7328, 2688, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 7072, 2688, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 2144, 992, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 2144, 1216, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 2144, 1408, 270, 0, 0, 0, 2505},
		{MT_PSO_UNLOCKCARD, 4608, 2624, 1, 0, 0, 2, 2502},
		{MT_PSO_CARDREADER, 4288, 2848, 270, 0, 0, 1, 2503},
		{MT_PSO_ROOMANCHOR, 2624, 4992, 1, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 4256, 3424, 1, 0, 0, 0, 2500},
		{9, 3296, 4576, 0, 512, 32, 0, 103},
		{17, 3328, 4256, 0, 0, 0, 0, 111},
		{6, 3296, 3808, 0, 0, 0, 0, 100},
		{MT_PSO_LASERTOWER, 2656, 4896, 150, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 2656, 4224, 151, 0, 0, 1, 2504},
		{MT_PSO_UNLOCKCARD, 2976, 4576, 1, 0, 0, 0, 2502},
		{MT_PSO_CARDREADER, 2816, 4832, 0, 0, 0, 1, 2503},
		{MT_PSO_CRATE, 2912, 3616, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 224, 4032, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 512, 4032, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 800, 4032, 270, 0, 0, 0, 2505},
		{MT_PSO_LASERTOWER, 96, 3232, 200, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 576, 3232, 201, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 1056, 3232, 202, 0, 0, 0, 2504},
		{MT_PSO_ROOMANCHOR, -3680, 5536, 2, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -480, 3808, 2, 0, 0, 0, 2500},
		{9, -2624, 4768, 0, 512, 32, 0, 103},
		{9, -2752, 4448, 0, 512, 32, 0, 103},
		{9, -2944, 4640, 0, 512, 32, 0, 103},
		{17, -3136, 5024, 0, 0, 0, 0, 111},
		{17, -3168, 4576, 0, 0, 0, 0, 111},
		{MT_PSO_CRATE, -2912, 5312, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -2624, 5312, 270, 0, 0, 0, 2505},
		{MT_PSO_LASERTOWER, -2976, 5472, 210, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -2496, 5472, 211, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -2016, 5472, 212, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -3552, 4672, 220, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -3552, 4352, 221, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -3552, 4000, 222, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, -3424, 3936, 0, 0, 0, 1, 2503},
		{MT_PSO_UNLOCKCARD, -3328, 4832, 1, 0, 0, 0, 2502},
		{MT_PSO_LASERTOWER, -5440, 2752, 230, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -5024, 2752, 231, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -4544, 2752, 232, 0, 0, 0, 2504},
		{MT_PSO_CRATE, -5248, 2880, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -4768, 2880, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -5248, 3072, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -4768, 3072, 270, 0, 0, 0, 2505},
		{MT_PSO_ROOMANCHOR, -7488, 5312, 3, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -6176, 3360, 3, 0, 0, 0, 2500},
		{9, -7264, 4352, 0, 512, 32, 0, 103},
		{9, -7264, 4096, 0, 512, 32, 0, 103},
		{MT_PSO_LASERTOWER, -8928, 5536, 260, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -8928, 5824, 261, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -8928, 6112, 262, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -8992, 5536, 270, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -9440, 5536, 271, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -9824, 5536, 272, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -9824, 5792, 273, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -9824, 6048, 274, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -9824, 6304, 275, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -8192, 8288, 280, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -7872, 8288, 281, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -7552, 8288, 282, 0, 0, 1, 2504},
		{13, -8256, 7008, 270, 0, 0, 0, 107},
		{17, -8608, 7872, 0, 0, 0, 0, 111},
		{17, -7744, 7808, 0, 0, 0, 0, 111},
		{17, -6944, 7840, 0, 0, 0, 0, 111},
		{MT_PSO_ROOMANCHOR, -9888, 8384, 4, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -6432, 5472, 4, 0, 0, 0, 2500},
		{MT_PSO_UNLOCKCARD, -8704, 8064, 1, 0, 0, 0, 2502},
		{MT_PSO_CARDREADER, -8192, 8160, 270, 0, 0, 1, 2503},
		{MT_PSO_LASERTOWER, -7520, 8992, 290, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -7520, 9248, 291, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -7520, 9568, 292, 0, 0, 0, 2504},
		{MT_PSO_CRATE, -8704, 6016, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -8704, 5824, 270, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -8704, 5632, 270, 0, 0, 0, 2505},
		{MT_PSO_ROOMANCHOR, -10272, 6944, 5, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -14432, 9856, 5, 0, 0, 0, 2500},
		{MT_PSO_CRATE, -11584, 14560, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -11424, 14560, 0, 1, 0, 0, 2505},
		{6, -12544, 7744, 0, 0, 0, 0, 100},
		{MT_PSO_LASERTOWER, -14336, 9760, 300, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -14048, 9760, 301, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -13760, 9760, 302, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, -14304, 9664, 270, 0, 0, 1, 2503},
		{MT_PSO_UNLOCKCARD, -13888, 8096, 1, 0, 0, 0, 2502},
		{MT_PSO_TELEPORTER, 6560, -288, 1, 1, 0, 0, 2510},
		{MT_PSO_TELEPORTER, -12192, 10112, 3, 0, 0, 0, 2510},
		{MT_PSO_TELEPORT_DEST, -12224, 12032, 3, 0, 0, 0, 2511},
		{MT_PSO_ROOMANCHOR, -14368, 15648, 6, 1, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -9760, 11520, 6, 1, 0, 0, 2500},
		{MT_PSO_TELEPORTER, -12160, 14720, 1, 1, 0, 1, 2510},
		{MT_PSO_CRATE, -12864, 14848, 0, 1, 0, 1, 2505},
		{MT_PSO_CRATE, -12704, 14848, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -12544, 14848, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -12864, 14720, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -12704, 14720, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -12544, 14720, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -12864, 14592, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -12704, 14592, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -12544, 14592, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -11744, 14816, 0, 1, 0, 1, 2505},
		{MT_PSO_CRATE, -11584, 14816, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -11424, 14816, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -11744, 14688, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -11584, 14688, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -11424, 14688, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, -11744, 14560, 0, 1, 0, 0, 2505},
		{9, -12768, 8128, 0, 512, 32, 0, 103},
		{9, -12800, 7520, 0, 512, 32, 0, 103},
		{MT_PSO_TELEPORT_DEST, 6560, -192, 0, 1, 0, 0, 2511},
	},
})