local mapnum = 4
table.insert(PSO.info.questmaps, {mapnum, true})	-- map starts off locked
PSO.info.quests[mapnum] = {}

/*
	quest format:
	{
		>>COSMETIC STUFF
		name: 		quest name
		objective:	description of the objective
		desc: 		description
	
	
		>>ACTUAL GAMEPLAY RELEVANT STUFF
		map:		map number the quest takes place in
					(players will be warped to it as soon as everyone gets to the teleporter)
		
		layout = {}: 	object layout for the map.
						worth noting the object layout CANNOT be changed in the lobby.
		
		levels = {                                                                    ,..,.,.,.,.,.,..        
			[DIFF_NORMAL] = x,
			[DIFF_HARD] = x,
			[...]
		}: enemy level per difficulty
		
		
		
	}
*/

/*table.insert(PSO.info.quests[mapnum], {
	
	name = "Test quest",
	desc = "Doesn't load object layout, enemy level matches player level",
	objective = "Test your shit",
	
	map = 1,
	
	levels = {
		[DIFF_NORMAL] = 1,
		[DIFF_HARD] = 1,
		[DIFF_VERYHARD] = 1,
		[DIFF_SUPERHARD] = 1,
		[DIFF_EXTREMELYHARD] = 1,
		[DIFF_ULTRAHARD] = 1,
	},
})*/


table.insert(PSO.info.quests[mapnum], {
	
	name = "3-1: Cold Expedition",
	desc = "An unusually high concentration of Badniks has been detected in a remote mountainous region. Commence the suppression operation.",
	objective = "Make your way through the mountain",
	
	map = mapnum,

	locked = true,		-- initially locked
	unlocks = {{4,2 }},	-- unlocks 3-2

	drops = {
		[DIFF_NORMAL] = {	
			{"pine", 1, 0, 5, 100},
			{"burster", 1, 0, 5, 100},
			{"crest", 1, 0, 5, 100},
			{"claw", 0, 0, 5, 100},
			{"peacekeeper", 0, 0, 5, 100},
			{"hammer", 0, 0, 5, 100},			
			
			{"unit_hp_2", 1, 0, 2, 50},
			{"unit_pp_2", 1, 0, 2, 50},
			{"unit_satk_2", 1, 0, 2, 50},
			{"unit_tatk_2", 1, 0, 2, 50},
			{"unit_ratk_2", 1, 0, 2, 50},
			
			{"icicle frame", 1, 0, 1, 50},
		},

		[DIFF_HARD] = {	
			{"alva pine", 1, 0, 5, 50},
			{"alva burster", 0, 0, 5, 50},
			{"alva crest", 0, 0, 5, 50},			

			{"alva doubliss", 1, 0, 5, 100},
			{"alva concentrator", 1, 0, 5, 100},
			
			{"unit_ppsatk_2", 1, 0, 7, 50},
			{"unit_pptatk_2", 1, 0, 7, 50},
			{"unit_ppratk_2", 1, 0, 7, 50},
			{"unit_rainbow_2", 1, 0, 7, 50},

			{"winginator", 1, 0, 1, 100},
			{"asterod", 1, 0, 1, 100},
			{"fehler frame", 1, 0, 5, 100},
			
			{6000, nil, nil, 1, 5},
		},
		
	},
	
	levels = {
		[DIFF_NORMAL] = 20,
		[DIFF_HARD] = 41,
	},

	grading = {
		{QG_TIME, 50, 0, TICRATE*60*15, TICRATE*60*20},
		{QG_DAMAGETAKEN, 40, 0, 350, 600},
		{QG_NOINCAP, 10},
	},
	
	layout = {
		{0, 9600, 384, 180, 0, 0, 0, 1},
		{MT_PSO_LASERTOWER, 5664, 96, 0, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 5664, 320, 1, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 5664, 576, 2, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 5664, 832, 3, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, 5760, 192, 0, 0, 0, 1, 2503},
		{595, 4128, -2208, 180, 0, 0, 2, 129},
		{MT_PSO_ROOMANCHOR, 5600, 928, 1, 0, 0, 0, 2500},
		{7, 7232, 352, 0, 0, 0, 0, 101},
		{7, 7232, 704, 0, 0, 0, 0, 101},
		{595, 6944, 544, 0, 0, 0, 0, 129},
		{595, 6720, 448, 0, 0, 0, 1, 129},
		{595, 6720, 640, 0, 0, 0, 1, 129},
		{17, 8000, 320, 180, 0, 0, 1, 111},
		{17, 8032, 704, 180, 0, 0, 1, 111},
		{MT_PSO_UNLOCKCARD, 6144, 480, 1, 0, 0, 1, 2502},
		{MT_PSO_CRATE, 5472, 960, 180, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 5248, 992, 180, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 5376, 1152, 180, 0, 0, 0, 2505},
		{596, 4576, -2400, 270, 0, 0, 2, 130},
		{595, 4128, -2656, 180, 0, 0, 2, 129},
		{9, 5504, -1952, 90, 256, 16, 0, 103},
		{9, 5024, -2016, 90, 256, 16, 0, 103},
		{595, 5216, -1632, 90, 0, 0, 0, 129},
		{8, 2752, -2624, 180, 0, 0, 1, 102},
		{8, 3200, -2304, 180, 0, 0, 1, 102},
		{7, 3744, -2432, 0, 0, 0, 1, 101},
		{MT_PSO_ROOMANCHOR, 8192, -64, 1, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 320, -576, 2, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 6080, -3360, 2, 0, 0, 0, 2500},
		{MT_PSO_UNLOCKCARD, 1280, -2336, 1, 0, 0, 2, 2502},
		{MT_PSO_LASERTOWER, 864, -2944, 10, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 1120, -2944, 11, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 1440, -2944, 12, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 1696, -2944, 13, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, 800, -2848, 90, 0, 0, 1, 2503},
		{MT_PSO_ROOMANCHOR, 1888, -3712, 3, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 4864, -4864, 3, 0, 0, 0, 2500},
		{596, 3968, -4224, 180, 0, 0, 0, 130},
		{7, 3104, -3936, 180, 0, 0, 0, 101},
		{7, 3232, -4192, 180, 0, 0, 0, 101},
		{7, 3104, -4448, 180, 0, 0, 0, 101},
		{7, 2656, -3936, 0, 0, 0, 1, 101},
		{7, 2528, -4192, 0, 0, 0, 1, 101},
		{7, 2688, -4448, 0, 0, 0, 1, 101},
		{596, 1952, -4224, 0, 0, 0, 1, 130},
		{MT_PSO_JUMPPAD, 5632, -7968, 0, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 6336, -7360, 0, 5120, 320, 0, 2513},
		{MT_PSO_JUMPPAD, 7136, -7776, 0, 0, 0, 0, 2512},
		{595, 6144, -6848, 90, 5120, 320, 0, 129},
		{595, 6496, -6848, 90, 5120, 320, 0, 129},
		{596, 5568, -7040, 90, 0, 0, 0, 130},
		{596, 7008, -6816, 90, 0, 0, 0, 130},
		{41, 6336, -7904, 90, 5120, 320, 1, 123},
		{6, 6496, -7648, 90, 5120, 320, 1, 100},
		{6, 6176, -7648, 90, 5120, 320, 1, 100},
		{17, 5984, -6240, 0, 0, 0, 2, 111},
		{17, 6624, -6240, 0, 0, 0, 2, 111},
		{17, 6048, -8224, 0, 0, 0, 2, 111},
		{17, 6752, -8224, 0, 0, 0, 2, 111},
		{595, 6112, -7456, 0, 0, 0, 2, 129},
		{595, 6336, -7104, 0, 0, 0, 2, 129},
		{595, 6528, -7456, 0, 0, 0, 2, 129},
		{MT_PSO_UNLOCKCARD, 6336, -7232, 1, 5120, 320, 2, 2502},
		{MT_PSO_CRATE, 5504, -6336, 180, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 5632, -6176, 180, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 6944, -5920, 180, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 7072, -6176, 180, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 7296, -8448, 180, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 7136, -8704, 180, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 5536, -8480, 180, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 5728, -8704, 180, 0, 0, 0, 2505},
		{MT_PSO_LASERTOWER, 4800, -3968, 20, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 4800, -4160, 21, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 4800, -4416, 22, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, 4672, -4512, 180, 0, 0, 1, 2503},
		{MT_PSO_UNLOCKCARD, 4192, -4224, 1, 0, 0, 1, 2502},
		{MT_PSO_ROOMANCHOR, 5216, -5440, 4, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 7776, -9184, 4, 0, 0, 0, 2500},
		{MT_PSO_LASERTOWER, 5696, -1440, 50, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 5696, -1728, 51, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 5696, -2080, 52, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 5696, -2368, 53, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 3168, -4800, 60, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 3008, -4800, 61, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 2784, -4800, 62, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 2624, -4800, 63, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 5376, -7328, 70, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 5376, -7456, 71, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 5376, -7584, 72, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 5376, -7680, 73, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 928, -11104, 80, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 928, -10976, 81, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 1056, -10976, 82, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 1184, -10976, 83, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 1184, -11104, 84, 0, 0, 1, 2504},
		{MT_PSO_ROOMANCHOR, -576, -9568, 5, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 3264, -11136, 5, 0, 0, 0, 2500},
		{MT_PSO_CRATE, -192, -10464, 45, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -64, -10624, 45, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 3488, -9568, 45, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 3616, -9728, 45, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 3360, -9632, 45, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 4256, -13600, 45, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 3712, -9600, 45, 0, 0, 0, 2505},
		{595, 2656, -10304, 0, 0, 0, 0, 129},
		{595, 2656, -10688, 0, 0, 0, 0, 129},
		{596, 1664, -10528, 0, 0, 0, 0, 130},
		{596, 2656, -10496, 0, 0, 0, 1, 130},
		{41, 1312, -10304, 315, 0, 0, 1, 123},
		{41, 1312, -10784, 45, 0, 0, 1, 123},
		{MT_PSO_CRATE, 4416, -13440, 45, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -64, -10304, 45, 0, 0, 0, 2505},
		{7, 1024, -10400, 0, 0, 0, 2, 101},
		{7, 1024, -10688, 0, 0, 0, 2, 101},
		{7, 2528, -10400, 180, 0, 0, 2, 101},
		{7, 2528, -10688, 180, 0, 0, 2, 101},
		{596, 1856, -10176, 270, 0, 0, 2, 130},
		{596, 1856, -10880, 90, 0, 0, 2, 130},
		{596, 2720, -10496, 180, 0, 0, 2, 130},
		{596, 928, -10528, 0, 0, 0, 2, 130},
		{MT_PSO_UNLOCKCARD, 1088, -10528, 1, 0, 0, 2, 2502},
		{MT_PSO_CARDREADER, 864, -10880, 90, 0, 0, 1, 2503},
		{MT_PSO_JUMPPAD, 1056, -11040, 50, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 320, -11008, 50, 0, 0, 0, 2513},
		{MT_PSO_ROOMANCHOR, 576, -11232, 6, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 5312, -12896, 6, 0, 0, 0, 2500},
		{7, 1760, -12384, 180, 0, 0, 0, 101},
		{7, 1696, -12608, 180, 0, 0, 0, 101},
		{17, 2080, -12480, 0, 0, 0, 0, 111},
		{17, 1344, -12256, 0, 0, 0, 1, 111},
		{17, 1280, -12608, 0, 0, 0, 1, 111},
		{7, 2176, -12192, 225, 0, 0, 1, 101},
		{7, 2400, -12448, 225, 0, 0, 1, 101},
		{17, 1632, -12384, 0, 0, 0, 2, 111},
		{17, 1600, -12576, 0, 0, 0, 2, 111},
		{17, 2784, -11424, 0, 0, 0, 2, 111},
		{17, 2848, -11808, 0, 0, 0, 2, 111},
		{595, 2432, -11744, 225, 0, 0, 2, 129},
		{595, 1696, -12480, 0, 0, 0, 2, 129},
		{595, 3552, -11392, 180, 0, 0, 3, 129},
		{595, 3520, -11616, 180, 0, 0, 3, 129},
		{17, 1952, -12224, 0, 0, 0, 3, 111},
		{17, 2496, -12192, 0, 0, 0, 3, 111},
		{MT_PSO_UNLOCKCARD, 4160, -12032, 1, 0, 0, 3, 2502},
		{MT_PSO_LASERTOWER, 4000, -12384, 120, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 4160, -12384, 121, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 4288, -12384, 122, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 4416, -12384, 123, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, 3936, -12256, 90, 0, 0, 1, 2503},
		{MT_PSO_CRATE, 4224, -13280, 45, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 4448, -13696, 45, 0, 0, 0, 2505},
		{MT_PSO_ROOMANCHOR, 5088, -11232, 7, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 11296, -15296, 7, 0, 0, 0, 2500},
		{41, 5664, -13440, 180, 0, 0, 0, 123},
		{41, 5664, -13760, 180, 0, 0, 0, 123},
		{596, 6208, -13600, 180, 0, 0, 0, 130},
		{595, 6048, -13408, 180, 0, 0, 1, 129},
		{595, 6048, -13792, 180, 0, 0, 1, 129},
		{596, 5440, -13440, 0, 0, 0, 1, 130},
		{596, 5440, -13760, 0, 0, 0, 1, 130},
		{MT_PSO_UNLOCKCARD, 5952, -13568, 1, 0, 0, 1, 2502},
		{MT_PSO_LASERTOWER, 6400, -13216, 130, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 6400, -13472, 131, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 6400, -13760, 132, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 6400, -13984, 133, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, 6304, -13248, 180, 1, 0, 1, 2503},
		{MT_PSO_JUMPPAD, 6624, -13568, 300, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 6752, -12896, 300, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, 6752, -12672, 301, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 6720, -11968, 301, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, 6912, -11808, 302, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 7872, -11712, 302, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, 8032, -11872, 303, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 6368, -13952, 303, 0, 0, 0, 2513},
		{MT_PSO_CRATE, 6944, -12768, 45, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 6688, -11680, 45, 0, 0, 0, 2505},
		{41, 8576, -11808, 180, 0, 0, 2, 123},
		{596, 9024, -12608, 135, 0, 0, 2, 130},
		{596, 9440, -12480, 135, 0, 0, 2, 130},
		{595, 8800, -11712, 180, 0, 0, 2, 129},
		{595, 8864, -11872, 180, 0, 0, 2, 129},
		{MT_PSO_JUMPPAD, 9440, -12000, 305, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 9600, -12512, 305, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, 9280, -12512, 306, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 9312, -12000, 306, 0, 0, 0, 2513},
		{7, 9920, -12896, 90, 0, 0, 3, 101},
		{7, 8928, -12960, 90, 0, 0, 3, 101},
		{596, 9056, -11904, 270, 0, 0, 3, 130},
		{596, 9568, -11968, 270, 0, 0, 3, 130},
		{41, 9440, -13408, 180, 0, 0, 3, 123},
		{MT_PSO_UNLOCKCARD, 9632, -11872, 2, 0, 0, 3, 2502},
		{MT_PSO_LASERTOWER, 9408, -11616, 140, 1, 0, 2, 2504},
		{MT_PSO_LASERTOWER, 9632, -11616, 141, 0, 0, 2, 2504},
		{MT_PSO_LASERTOWER, 9856, -11616, 142, 0, 0, 2, 2504},
		{MT_PSO_CARDREADER, 9888, -11680, 270, 1, 0, 2, 2503},
		{MT_PSO_CRATE, 8864, -10304, 45, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 9760, -10208, 45, 0, 0, 0, 2505},
		{MT_PSO_LASERTOWER, 11104, -9120, 150, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 11264, -9056, 151, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 11440, -8992, 152, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 11584, -8960, 153, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 8960, -5888, 160, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 9408, -5888, 161, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 9792, -5888, 162, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 10240, -5888, 163, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 10656, -5888, 164, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 11008, -5888, 165, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 11424, -5888, 166, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 11840, -5888, 167, 0, 0, 0, 2504},
		{MT_PSO_ROOMANCHOR, 7904, -5888, 8, 1, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 12160, -9280, 8, 0, 0, 0, 2500},
		{MT_PSO_TELEPORTER, 9824, 384, 1, 1, 0, 0, 2510},
		{596, 9280, -6912, 315, 0, 0, 0, 130},
		{MT_PSO_TELEPORTER, 10432, -8992, 1, 1, 0, 3, 2510},
		{596, 11168, -6976, 180, 0, 0, 0, 130},
		{MT_PSO_TELEPORT_DEST, 9696, 384, 0, 0, 0, 0, 2511},
		{41, 9856, -6688, 270, 0, 0, 1, 123},
		{41, 10400, -6688, 270, 0, 0, 1, 123},
		{595, 8960, -7072, 315, 0, 0, 1, 129},
		{595, 8896, -7552, 0, 0, 0, 1, 129},
		{595, 11584, -7488, 180, 0, 0, 1, 129},
		{595, 11072, -6848, 225, 0, 0, 1, 129},
		{596, 8896, -7296, 0, 0, 0, 2, 130},
		{595, 11360, -7264, 180, 0, 0, 1, 129},
		{41, 9856, -7776, 90, 0, 0, 2, 123},
		{41, 10496, -7776, 90, 0, 0, 2, 123},
		{MT_PSO_CRATE, 10176, -8576, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, 10336, -8512, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, 10560, -8576, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, 10208, -8704, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, 10400, -8640, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, 10624, -8704, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, 10048, -8800, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, 10048, -8672, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, 10112, -8928, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, 10240, -8832, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, 10464, -8800, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, 10624, -8832, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, 10752, -8640, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, 10816, -8800, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, 10848, -8960, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, 10336, -8928, 0, 5, 0, 2, 2505},
		{MT_PSO_CRATE, 10560, -8928, 0, 5, 0, 2, 2505},
		{8, 9920, -7200, 0, 0, 0, 0, 102},
		{8, 10400, -7200, 0, 0, 0, 0, 102},
		{8, 10176, -7456, 0, 0, 0, 0, 102},
		{8, 10176, -7008, 0, 0, 0, 0, 102},
		{MT_PSO_LASERTOWER, 6016, -9152, 220, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 6224, -9152, 221, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 6448, -9152, 222, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 6656, -9152, 223, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 6864, -9152, 224, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, 6048, -9056, 90, 0, 0, 1, 2503},
	}
})

table.insert(PSO.info.quests[mapnum], {
	
	name = "3-2: Freezing Cliffs",
	desc = "Continue the enemy suppression operation by clearing the enemies remaining on the outskirts of the area, watch out for ambushes on the cliffs.",
	objective = "Clear the remaining enemies on the mountainside",
	
	map = mapnum,

	locked = true,		-- initially locked
	unlocks = {{4, 3}},	-- unlocks 3-3

	drops = {
		[DIFF_NORMAL] = {	
			{"pine", 1, 0, 5, 100},
			{"burster", 1, 0, 5, 100},
			{"crest", 1, 0, 5, 100},
			{"claw", 0, 0, 5, 100},
			{"peacekeeper", 0, 0, 5, 100},
			{"hammer", 0, 0, 5, 100},			
			
			{"unit_hp_2", 1, 0, 2, 50},
			{"unit_pp_2", 1, 0, 2, 50},
			{"unit_satk_2", 1, 0, 2, 50},
			{"unit_tatk_2", 1, 0, 2, 50},
			{"unit_ratk_2", 1, 0, 2, 50},
			
			{"icicle frame", 1, 0, 1, 50},
		},

		[DIFF_HARD] = {	
			{"alva pine", 1, 0, 5, 50},
			{"alva burster", 0, 0, 5, 50},
			{"alva crest", 0, 0, 5, 50},			

			{"alva doubliss", 1, 0, 5, 100},
			{"alva concentrator", 1, 0, 5, 100},
			
			{"unit_ppsatk_2", 1, 0, 7, 50},
			{"unit_pptatk_2", 1, 0, 7, 50},
			{"unit_ppratk_2", 1, 0, 7, 50},
			{"unit_rainbow_2", 1, 0, 7, 50},

			{"winginator", 1, 0, 1, 100},
			{"asterod", 1, 0, 1, 100},
			{"fehler frame", 1, 0, 5, 100},
			
			{6000, nil, nil, 1, 5},
		},
		
	},
	
	levels = {
		[DIFF_NORMAL] = 23,
		[DIFF_HARD] = 43,
	},

	grading = {
		{QG_TIME, 55, 0, TICRATE*60*13, TICRATE*60*15},
		{QG_DAMAGETAKEN, 45, 0, 350, 600},
		{QG_NOINCAP, 10},
	},
	
	layout = {
		{0, 10208, -4000, 180, 0, 0, 0, 1},
		{MT_PSO_TELEPORTER, 10688, -4352, 1, 1, 0, 0, 2510},
		{MT_PSO_TELEPORT_DEST, 10336, -4000, 0, 0, 0, 0, 2511},
		{MT_PSO_LASERTOWER, 10016, -4864, 0, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 10272, -4864, 1, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 10528, -4864, 2, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 10784, -4864, 3, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 11008, -4864, 4, 0, 0, 0, 2504},
		{MT_PSO_CRATE, 9568, -1792, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 9856, -1952, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 9632, -2176, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 9920, -2304, 0, 0, 0, 0, 2505},
		{MT_PSO_ROOMANCHOR, 9536, -2944, 0, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 6368, -1088, 0, 0, 0, 0, 2500},
		{8, 8544, -2432, 0, 0, 0, 0, 102},
		{8, 9184, -2304, 0, 0, 0, 0, 102},
		{595, 7808, -1984, 0, 0, 0, 0, 129},
		{595, 7616, -2304, 0, 0, 0, 0, 129},
		{41, 8992, -1920, 180, 0, 0, 1, 123},
		{41, 7296, -2048, 0, 0, 0, 1, 123},
		{17, 8064, -2240, 0, 0, 0, 1, 111},
		{17, 8608, -1984, 0, 0, 0, 1, 111},
		{MT_PSO_LASERTOWER, 6816, -1536, 10, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 6816, -1696, 11, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 6816, -1872, 12, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 6816, -2064, 13, 0, 0, 1, 2504},
		{MT_PSO_UNLOCKCARD, 7296, -1856, 1, 1, 0, 1, 2502},
		{MT_PSO_CARDREADER, 7008, -2048, 0, 1, 0, 1, 2503},
		{MT_PSO_LASERTOWER, 5600, -736, 20, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 5408, -736, 21, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 5184, -736, 22, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 4928, -736, 23, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 4480, -1920, 30, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 4480, -2144, 31, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 4480, -2368, 32, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 4480, -2592, 33, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 4480, -2848, 34, 0, 0, 0, 2504},
		{MT_PSO_CRATE, 4640, -2112, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 4672, -2496, 0, 0, 0, 0, 2505},
		{MT_PSO_JUMPPAD, 4768, -1152, 0, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 3808, -1056, 0, 0, 0, 0, 2513},
		{MT_PSO_ROOMANCHOR, -3360, 2528, 1, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 4288, -1728, 1, 0, 0, 0, 2500},
		{41, 1376, 0, 315, 0, 0, 0, 123},
		{41, 1632, 352, 315, 0, 0, 0, 123},
		{6, 2336, -224, 315, 0, 0, 0, 100},
		{6, 2144, -480, 315, 0, 0, 0, 100},
		{41, -224, 1504, 315, 0, 0, 1, 123},
		{41, -1344, -480, 45, 0, 0, 1, 123},
		{7, 160, 320, 0, 0, 0, 1, 101},
		{7, 608, 1024, 0, 0, 0, 1, 101},
		{17, 2528, -672, 0, 0, 0, 2, 111},
		{17, 2656, -512, 0, 0, 0, 2, 111},
		{17, 2784, -352, 0, 0, 0, 2, 111},
		{7, 288, 608, 315, 0, 0, 2, 101},
		{7, 288, 128, 0, 0, 0, 2, 101},
		{7, -64, 1600, 315, 0, 0, 2, 101},
		{7, -384, 1248, 0, 0, 0, 2, 101},
		{7, -1184, -224, 0, 0, 0, 2, 101},
		{7, -1088, -480, 0, 0, 0, 2, 101},
		{MT_PSO_UNLOCKCARD, 32, 224, 1, 0, 0, 2, 2502},
		{MT_PSO_LASERTOWER, -1696, -128, 50, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -1696, -288, 51, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -1696, -480, 52, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -1696, -704, 53, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -1696, -960, 54, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -1696, -1184, 55, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -2224, -1008, 60, 1, 0, 2, 2504},
		{MT_PSO_LASERTOWER, -2224, -1104, 61, 0, 0, 2, 2504},
		{MT_PSO_LASERTOWER, -2224, -1216, 62, 0, 0, 2, 2504},
		{MT_PSO_LASERTOWER, -2224, -1312, 63, 0, 0, 2, 2504},
		{MT_PSO_LASERTOWER, -2464, -800, 70, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -2624, -800, 71, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -2784, -800, 72, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -2944, -800, 73, 0, 0, 0, 2504},
		{MT_PSO_CARDREADER, -1600, -1088, 0, 0, 0, 1, 2503},
		{MT_PSO_CARDREADER, -2112, -1024, 0, 0, 0, 2, 2503},
		{MT_PSO_JUMPPAD, -2016, -1216, 10, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -1248, -3360, 10, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, -2432, -1216, 30, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 1088, -2272, 30, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, -1248, -3040, 20, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -1472, -416, 20, 0, 0, 0, 2513},
		{MT_PSO_ROOMANCHOR, -2272, -2912, 2, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, -768, -6144, 2, 0, 0, 0, 2500},
		{7, -1504, -3872, 90, 0, 0, 0, 101},
		{7, -1152, -3904, 90, 0, 0, 0, 101},
		{41, -1312, -4896, 90, 0, 0, 0, 123},
		{596, -1344, -3776, 270, 0, 0, 1, 130},
		{595, -1472, -4800, 90, 0, 0, 1, 129},
		{595, -1152, -4800, 90, 0, 0, 1, 129},
		{596, -1504, -5408, 90, 0, 0, 2, 130},
		{596, -1344, -3968, 270, 0, 0, 2, 130},
		{7, -1440, -4128, 270, 0, 0, 2, 101},
		{7, -1184, -4608, 90, 0, 0, 2, 101},
		{MT_PSO_UNLOCKCARD, -1440, -5216, 2, 0, 0, 2, 2502},
		{MT_PSO_CRATE, -1888, -5632, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -1728, -5856, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -1440, -5696, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -1280, -5952, 0, 0, 0, 0, 2505},
		{MT_PSO_LASERTOWER, 1760, -2912, 100, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 1760, -2752, 101, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 1760, -2496, 102, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 1760, -2272, 103, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 1760, -2048, 104, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 1760, -1824, 105, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 3264, -4704, 110, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 3264, -4512, 111, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 3264, -4320, 112, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 3264, -4128, 113, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 3264, -3904, 114, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 3264, -3680, 115, 0, 0, 0, 2504},
		{MT_PSO_CRATE, 3456, -5152, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 3776, -5280, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 3360, -5696, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 3648, -5632, 0, 0, 0, 0, 2505},
		{MT_PSO_ROOMANCHOR, 736, -3648, 3, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 3392, -4800, 3, 0, 0, 0, 2500},
		{7, 1888, -4032, 180, 0, 0, 0, 101},
		{7, 1792, -4352, 180, 0, 0, 0, 101},
		{596, 2688, -4192, 180, 0, 0, 0, 130},
		{41, 2464, -4032, 180, 0, 0, 1, 123},
		{41, 2496, -4320, 180, 0, 0, 1, 123},
		{596, 3040, -3776, 180, 0, 0, 2, 130},
		{596, 3104, -4640, 180, 0, 0, 2, 130},
		{7, 2272, -4032, 180, 0, 0, 2, 101},
		{7, 2272, -4288, 180, 0, 0, 2, 101},
		{MT_PSO_UNLOCKCARD, 2880, -4352, 1, 0, 0, 2, 2502},
		{MT_PSO_LASERTOWER, 2624, -4768, 120, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 2816, -4768, 121, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 3008, -4768, 122, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 3168, -4768, 123, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, 2656, -4704, 90, 0, 0, 1, 2503},
		{MT_PSO_JUMPPAD, 1216, -6048, 500, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 864, -7584, 500, 0, 0, 0, 2513},
		{MT_PSO_ROOMANCHOR, -384, -6240, 4, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 2656, -9504, 4, 0, 0, 0, 2500},
		{MT_PSO_LASERTOWER, 320, -7424, 130, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 544, -7424, 131, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 768, -7424, 132, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 768, -7264, 133, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 768, -7072, 134, 0, 0, 1, 2504},
		{595, 384, -7872, 90, 0, 0, 0, 129},
		{595, 768, -8000, 90, 0, 0, 0, 129},
		{7, 512, -8192, 90, 0, 0, 0, 101},
		{17, 512, -8960, 0, 0, 0, 0, 111},
		{17, 1600, -8256, 0, 0, 0, 0, 111},
		{17, 2016, -7072, 0, 0, 0, 0, 111},
		{MT_PSO_JUMPPAD, 1312, -7360, 1000, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 2048, -7168, 1000, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, 2144, -7168, 500, 0, 0, 0, 2512},
		{MT_PSO_JUMPPAD, 1600, -8320, 500, 0, 0, 0, 2512},
		{MT_PSO_JUMPPAD, 416, -8896, 500, 0, 0, 0, 2512},
		{MT_PSO_JUMPPAD, 1184, -7904, 1001, 0, 0, 0, 2512},
		{MT_PSO_JUMPPAD, 608, -8416, 1002, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 1760, -8352, 1001, 0, 0, 0, 2513},
		{MT_PSO_JUMPTARGET, 480, -9056, 1002, 0, 0, 0, 2513},
		{41, 1888, -8352, 135, 0, 0, 1, 123},
		{41, 2144, -7040, 180, 0, 0, 1, 123},
		{596, 416, -9024, 90, 0, 0, 1, 130},
		{41, 416, -7808, 90, 0, 0, 1, 123},
		{41, 672, -7968, 90, 0, 0, 1, 123},
		{MT_PSO_UNLOCKCARD, 672, -7712, 1, 0, 0, 1, 2502},
		{MT_PSO_CARDREADER, 288, -7520, 270, 0, 0, 1, 2503},
		{MT_PSO_JUMPPAD, 576, -7264, 1100, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 256, -6784, 1100, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, -32, -6848, 1101, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -1312, -6976, 1101, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, -1440, -7872, 1102, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -1344, -9056, 1102, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, -1344, -10048, 1103, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -1568, -11072, 1103, 0, 0, 0, 2513},
		{MT_PSO_CRATE, -1728, -7424, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -1568, -7040, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -1248, -9056, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, -1056, -9472, 0, 0, 0, 0, 2505},
		{MT_PSO_ROOMANCHOR, -4320, -10752, 5, 1, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 992, -15392, 5, 1, 0, 0, 2500},
		{MT_PSO_LASERTOWER, -2400, -12768, 200, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -2176, -12768, 201, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -1952, -12768, 202, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -1696, -12768, 203, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -1472, -12768, 204, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, -1248, -12768, 205, 0, 0, 1, 2504},
		{7, -1792, -11936, 90, 0, 0, 0, 101},
		{7, -1440, -11872, 90, 0, 0, 0, 101},
		{41, -1728, -12352, 90, 0, 0, 0, 123},
		{596, -1920, -13856, 90, 0, 0, 1, 130},
		{596, -2880, -13024, 45, 0, 0, 1, 130},
		{MT_PSO_JUMPPAD, -1952, -12960, 3000, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -2880, -13248, 3000, 0, 0, 0, 2513},
		{MT_PSO_CARDREADER, -2336, -12672, 90, 0, 0, 1, 2503},
		{MT_PSO_UNLOCKCARD, -1888, -12512, 1, 0, 0, 0, 2502},
		{7, -2112, -12640, 90, 0, 0, 1, 101},
		{7, -1696, -12640, 90, 0, 0, 1, 101},
		{595, -2624, -13888, 90, 0, 0, 1, 129},
		{41, -3584, -13728, 0, 0, 0, 2, 123},
		{41, -2464, -14464, 135, 0, 0, 2, 123},
		{MT_PSO_JUMPPAD, -2656, -13664, 3001, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -1888, -12672, 3001, 0, 0, 0, 2513},
		{17, -2272, -12992, 0, 0, 0, 2, 111},
		{17, -1888, -13152, 0, 0, 0, 2, 111},
		{MT_PSO_LASERTOWER, -1792, -13824, 210, 1, 0, 2, 2504},
		{MT_PSO_LASERTOWER, -1792, -13968, 211, 0, 0, 2, 2504},
		{MT_PSO_LASERTOWER, -1792, -14112, 212, 0, 0, 2, 2504},
		{MT_PSO_LASERTOWER, -1696, -14336, 220, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -1520, -14336, 221, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, -1360, -14336, 222, 0, 0, 0, 2504},
		{MT_PSO_CARDREADER, -2096, -14144, 180, 0, 0, 2, 2503},
		{MT_PSO_UNLOCKCARD, -2752, -13824, 2, 0, 0, 2, 2502},
		{MT_PSO_JUMPPAD, -1504, -14112, 3002, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -32, -13824, 3002, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, -192, -13408, 3001, 0, 0, 0, 2512},
		{MT_PSO_JUMPPAD, -128, -13888, 3003, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -2080, -13888, 3003, 0, 0, 0, 2513},
		{596, -96, -13312, 180, 0, 0, 3, 130},
		{596, 64, -13920, 180, 0, 0, 3, 130},
		{595, 224, -13440, 180, 0, 0, 3, 129},
		{595, 320, -13696, 180, 0, 0, 3, 129},
		{17, -1632, -13088, 0, 0, 0, 4, 111},
		{17, -1376, -12992, 0, 0, 0, 4, 111},
		{17, -1600, -13952, 0, 0, 0, 4, 111},
		{17, -1408, -14240, 0, 0, 0, 4, 111},
		{41, 32, -13600, 180, 0, 0, 4, 123},
		{7, -2080, -12896, 315, 0, 0, 4, 101},
		{7, -1696, -12864, 315, 0, 0, 4, 101},
		{7, -2400, -13792, 0, 0, 0, 4, 101},
		{7, -2688, -14016, 0, 0, 0, 4, 101},
		{MT_PSO_CRATE, 192, -13248, 0, 5, 0, 4, 2505},
		{MT_PSO_CRATE, 64, -13440, 0, 5, 0, 4, 2505},
		{MT_PSO_CRATE, 160, -13696, 0, 5, 0, 4, 2505},
		{MT_PSO_CRATE, 224, -13984, 0, 5, 0, 4, 2505},
		{MT_PSO_CRATE, 224, -14240, 0, 5, 0, 4, 2505},
		{MT_PSO_CRATE, 416, -14208, 0, 5, 0, 4, 2505},
		{MT_PSO_CRATE, 288, -13856, 0, 5, 0, 4, 2505},
		{MT_PSO_CRATE, 448, -14048, 0, 5, 0, 4, 2505},
		{MT_PSO_CRATE, 416, -13728, 0, 5, 0, 4, 2505},
		{MT_PSO_CRATE, 256, -13600, 0, 5, 0, 4, 2505},
		{MT_PSO_CRATE, 320, -13312, 0, 5, 0, 4, 2505},
		{MT_PSO_CRATE, 352, -13504, 0, 5, 0, 4, 2505},
		{MT_PSO_CRATE, 384, -13184, 0, 5, 0, 4, 2505},
		{MT_PSO_CRATE, 0, -13184, 0, 5, 0, 4, 2505},
		{MT_PSO_CRATE, -64, -13536, 0, 5, 0, 4, 2505},
		{MT_PSO_CRATE, -32, -13728, 0, 5, 0, 4, 2505},
		{MT_PSO_CRATE, 64, -14016, 0, 5, 0, 4, 2505},
		{MT_PSO_CRATE, 160, -14144, 0, 5, 0, 4, 2505},
		{MT_PSO_CRATE, 384, -14336, 0, 5, 0, 4, 2505},
		{MT_PSO_CRATE, 384, -13952, 0, 5, 0, 4, 2505},
		{MT_PSO_TELEPORTER, 544, -13664, 1, 1, 0, 5, 2510},
	}
})

table.insert(PSO.info.quests[mapnum], {
	
	name = "3-3: Duel at the summit",
	desc = "The Badnik unit issuing orders has been located at the summit. It gives a strong reading despite a seemingly small size, be careful.",
	objective = "Destroy the command unit!",
	
	map = mapnum,

	locked = true,		-- initially locked
	unlocks = {{5, 1}},	-- unlocks 4-1
	
	levels = {
		[DIFF_NORMAL] = 25,
		[DIFF_HARD] = 45,
	},

	grading = {
		{QG_TIME, 150, 0, TICRATE*60*12, TICRATE*60*15},
		{QG_DAMAGETAKEN, 50, 0, 350, 600},
		{QG_NOINCAP, 10},
	},
	
	layout = {
		{0, -1792, -12544, 90, 0, 0, 0, 1},
		{MT_PSO_TELEPORTER, -1792, -12704, 1, 1, 0, 0, 2510},
		{MT_PSO_TELEPORT_DEST, -1792, -12608, 0, 1, 0, 0, 2511},
		{MT_PSO_JUMPPAD, -1472, -13024, 0, 1, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -96, -13664, 0, 1, 0, 0, 2513},
		{MT_PSO_JUMPPAD, -160, -13792, 1, 1, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -1792, -12800, 1, 1, 0, 0, 2513},
		{MT_PSO_CRATE, 64, -13248, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 416, -13472, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 160, -13760, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 448, -14048, 0, 0, 0, 0, 2505},
		{MT_PSO_JUMPPAD, -1664, -11136, 2, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, -1280, -9728, 2, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, -1344, -9248, 3, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 704, -7744, 3, 0, 0, 0, 2513},
		{MT_PSO_ROOMANCHOR, -640, -6240, 0, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 3904, -9568, 0, 0, 0, 0, 2500},
		{595, 832, -7264, 270, 0, 0, 0, 129},
		{595, 1184, -7648, 180, 0, 0, 0, 129},
		{595, 960, -8000, 135, 0, 0, 0, 129},
		{17, 2016, -7072, 0, 0, 0, 0, 111},
		{17, 1600, -8320, 0, 0, 0, 0, 111},
		{17, 512, -8896, 0, 0, 0, 0, 111},
		{17, 288, -6912, 0, 0, 0, 0, 111},
		{MT_PSO_JUMPPAD, 544, -7328, 10, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 192, -6752, 10, 0, 0, 0, 2513},
		{MT_PSO_JUMPTARGET, 2240, -7040, 11, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, 1344, -7392, 11, 0, 0, 0, 2512},
		{MT_PSO_JUMPPAD, 1184, -7904, 12, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 1824, -8384, 12, 0, 0, 0, 2513},
		{MT_PSO_JUMPTARGET, 480, -9088, 13, 0, 0, 0, 2513},
		{MT_PSO_JUMPPAD, 608, -8416, 13, 0, 0, 0, 2512},
		{MT_PSO_JUMPPAD, 608, -8896, 3, 0, 0, 0, 2512},
		{MT_PSO_JUMPPAD, 1664, -8192, 3, 0, 0, 0, 2512},
		{MT_PSO_JUMPPAD, 2016, -6944, 3, 0, 0, 0, 2512},
		{MT_PSO_JUMPPAD, 384, -6784, 3, 0, 0, 0, 2512},
		{596, 320, -6816, 0, 0, 0, 1, 130},
		{596, 2144, -7168, 0, 0, 0, 1, 130},
		{596, 1792, -8288, 0, 0, 0, 1, 130},
		{596, 416, -8896, 0, 0, 0, 1, 130},
		{41, 512, -7936, 90, 0, 0, 1, 123},
		{41, 992, -7424, 180, 0, 0, 1, 123},
		{MT_PSO_LASERTOWER, 2048, -8096, 10, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 2048, -8256, 11, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 2048, -8480, 12, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 2048, -8640, 13, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, 1952, -8096, 180, 0, 0, 1, 2503},
		{MT_PSO_JUMPPAD, 2176, -8384, 20, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 3264, -7968, 20, 0, 0, 0, 2513},
		{MT_PSO_CRATE, 3200, -7136, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 3488, -7104, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 3616, -6976, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 3360, -6944, 0, 0, 0, 0, 2505},
		{MT_PSO_ROOMANCHOR, 5152, -5312, 1, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 7648, -9216, 1, 0, 0, 0, 2500},
		{MT_PSO_LASERTOWER, 6016, -9184, 30, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 6176, -9184, 31, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 6368, -9184, 32, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 6560, -9184, 33, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 6720, -9184, 34, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 6880, -9184, 35, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 5952, -5536, 40, 1, 0, 2, 2504},
		{MT_PSO_LASERTOWER, 6128, -5536, 41, 0, 0, 2, 2504},
		{MT_PSO_LASERTOWER, 6320, -5536, 42, 0, 0, 2, 2504},
		{MT_PSO_LASERTOWER, 6496, -5536, 43, 0, 0, 2, 2504},
		{MT_PSO_LASERTOWER, 6640, -5536, 44, 0, 0, 2, 2504},
		{MT_PSO_LASERTOWER, 7168, -7200, 50, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 6976, -7200, 51, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 6976, -7392, 52, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 7232, -7392, 53, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, 6912, -7360, 180, 0, 0, 1, 2503},
		{MT_PSO_JUMPPAD, 7072, -7296, 30, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 6336, -7264, 30, 5248, 328, 0, 2513},
		{17, 5792, -6816, 0, 0, 0, 0, 111},
		{17, 6816, -6688, 0, 0, 0, 0, 111},
		{17, 5920, -8160, 0, 0, 0, 0, 111},
		{17, 6912, -7968, 0, 0, 0, 0, 111},
		{595, 6272, -7328, 180, 0, 0, 0, 129},
		{595, 6272, -7552, 180, 0, 0, 0, 129},
		{595, 6432, -7328, 180, 0, 0, 1, 129},
		{595, 6432, -7552, 180, 0, 0, 1, 129},
		{41, 6304, -6624, 270, 0, 0, 1, 123},
		{41, 6400, -8480, 90, 0, 0, 1, 123},
		{MT_PSO_UNLOCKCARD, 6592, -7264, 1, 0, 0, 1, 2502},
		{7, 6112, -6432, 270, 5248, 328, 2, 101},
		{7, 6560, -6432, 270, 5248, 328, 2, 101},
		{7, 6176, -7840, 90, 5248, 328, 2, 101},
		{7, 6624, -7840, 90, 5248, 328, 2, 101},
		{41, 6240, -8608, 90, 5248, 328, 3, 123},
		{41, 6560, -8608, 90, 5248, 328, 3, 123},
		{41, 6080, -5952, 270, 5248, 328, 3, 123},
		{41, 6528, -5952, 270, 5248, 328, 3, 123},
		{MT_PSO_UNLOCKCARD, 6304, -5728, 2, 0, 0, 3, 2502},
		{MT_PSO_CARDREADER, 5984, -5600, 270, 0, 0, 2, 2503},
		{MT_PSO_ROOMANCHOR, 1632, -3456, 2, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 4320, -4896, 2, 0, 0, 2, 2500},
		{596, 1984, -3968, 0, 0, 0, 0, 130},
		{596, 1952, -4480, 0, 0, 0, 0, 130},
		{8, 2528, -4032, 0, 0, 0, 0, 102},
		{8, 2528, -4288, 0, 0, 0, 0, 102},
		{8, 3360, -4032, 180, 0, 0, 1, 102},
		{8, 3360, -4288, 180, 0, 0, 1, 102},
		{596, 3840, -3936, 180, 0, 0, 1, 130},
		{596, 3872, -4448, 180, 0, 0, 1, 130},
		{MT_PSO_LASERTOWER, 1824, -3760, 100, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 1824, -4048, 101, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 1824, -4320, 102, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 1824, -4560, 103, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 2624, -4800, 110, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 2752, -4800, 111, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 2880, -4800, 112, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 3040, -4800, 113, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 3168, -4800, 114, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 2496, -5088, 120, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 2496, -5280, 121, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 2496, -5504, 122, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 2496, -5696, 123, 0, 0, 0, 2504},
		{MT_PSO_CRATE, 3424, -5376, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 3296, -5056, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 3328, -5664, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 3680, -5216, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 3680, -5536, 0, 0, 0, 0, 2505},
		{MT_PSO_UNLOCKCARD, 1952, -4192, 1, 0, 0, 1, 2502},
		{MT_PSO_ROOMANCHOR, 1696, -1728, 3, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 4832, -3136, 3, 0, 0, 0, 2500},
		{MT_PSO_LASERTOWER, 4608, -1888, 130, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 4608, -2048, 131, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 4608, -2240, 132, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 4608, -2432, 133, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 4608, -2592, 134, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 4608, -2752, 135, 0, 0, 1, 2504},
		{MT_PSO_CRATE, 704, -2240, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 896, -1984, 0, 0, 0, 0, 2505},
		{8, 3680, -2048, 0, 0, 0, 0, 102},
		{8, 3712, -2560, 0, 0, 0, 0, 102},
		{41, 3168, -2144, 180, 0, 0, 0, 123},
		{41, 3168, -2432, 180, 0, 0, 0, 123},
		{41, 2016, -2144, 0, 0, 0, 1, 123},
		{41, 2016, -2464, 0, 0, 0, 1, 123},
		{595, 3040, -2144, 180, 0, 0, 1, 129},
		{595, 3040, -2432, 180, 0, 0, 1, 129},
		{MT_PSO_LASERTOWER, 5616, -1408, 140, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 5440, -1408, 141, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 5248, -1408, 142, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 5024, -1408, 143, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 4832, -1408, 144, 0, 0, 0, 2504},
		{MT_PSO_ROOMANCHOR, 5728, -1024, 4, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 10752, -3168, 4, 0, 0, 0, 2500},
		{MT_PSO_LASERTOWER, 8704, -2800, 150, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 8704, -2592, 151, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 8896, -2592, 152, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 9088, -2592, 153, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 9088, -2800, 154, 0, 0, 1, 2504},
		{MT_PSO_JUMPPAD, 8896, -2720, 500, 0, 0, 0, 2512},
		{MT_PSO_JUMPTARGET, 8896, -3136, 500, 0, 0, 0, 2513},
		{7, 7392, -1920, 135, 0, 0, 0, 101},
		{7, 7168, -2080, 135, 0, 0, 0, 101},
		{596, 7968, -2272, 180, 0, 0, 0, 130},
		{41, 6976, -1792, 315, 0, 0, 1, 123},
		{41, 8672, -1952, 180, 0, 0, 1, 123},
		{41, 9664, -2336, 180, 0, 0, 1, 123},
		{17, 9312, -1664, 0, 0, 0, 1, 111},
		{17, 9664, -1888, 0, 0, 0, 1, 111},
		{17, 7424, -2368, 0, 0, 0, 1, 111},
		{MT_PSO_UNLOCKCARD, 8896, -2432, 1, 0, 0, 1, 2502},
		{MT_PSO_CARDREADER, 8736, -2496, 90, 0, 0, 1, 2503},
		{MT_PSO_CRATE, 9984, -3680, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 10368, -3904, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 10112, -5216, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 10144, -5568, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 9728, -5632, 0, 0, 0, 0, 2505},
		{MT_PSO_LASERTOWER, 8720, -9440, 200, 1, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 8928, -9440, 201, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 9184, -9440, 202, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 9440, -9440, 203, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 9680, -9440, 204, 0, 0, 0, 2504},
		{MT_PSO_LASERTOWER, 11072, -9024, 210, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 11264, -9024, 211, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 11456, -9024, 212, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 11648, -9024, 213, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, 11008, -8864, 90, 0, 0, 1, 2503},
		{MT_PSO_ROOMANCHOR, 7936, -5920, 5, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 12224, -9472, 5, 0, 0, 0, 2500},
		{7, 11168, -6848, 135, 0, 0, 0, 101},
		{7, 11392, -7136, 135, 0, 0, 0, 101},
		{7, 9056, -6752, 45, 0, 0, 0, 101},
		{7, 8768, -7136, 45, 0, 0, 0, 101},
		{8, 9824, -6848, 0, 0, 0, 0, 102},
		{8, 10336, -6848, 0, 0, 0, 0, 102},
		{17, 10016, -8576, 0, 0, 0, 1, 111},
		{17, 10240, -8480, 0, 0, 0, 1, 111},
		{17, 10656, -8512, 0, 0, 0, 1, 111},
		{41, 9920, -7360, 90, 0, 0, 1, 123},
		{41, 10304, -7360, 90, 0, 0, 1, 123},
		{596, 8960, -7680, 90, 0, 0, 1, 130},
		{596, 11616, -7776, 90, 0, 0, 1, 130},
		{MT_PSO_UNLOCKCARD, 11136, -8640, 1, 0, 0, 1, 2502},
		{MT_PSO_CRATE, 11712, -10112, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 12704, -10112, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 13888, -10784, 0, 0, 0, 0, 2505},
		{MT_PSO_CRATE, 14144, -10432, 0, 0, 0, 0, 2505},
		{MT_PSO_ROOMANCHOR, 12480, -7232, 6, 0, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 14976, -9664, 6, 0, 0, 0, 2500},
		{7, 13024, -8832, 270, 0, 0, 0, 101},
		{7, 13440, -8640, 270, 0, 0, 0, 101},
		{41, 13216, -8384, 270, 0, 0, 0, 123},
		{41, 13024, -8576, 270, 0, 0, 1, 123},
		{41, 13344, -8512, 270, 0, 0, 1, 123},
		{596, 13056, -9664, 90, 0, 0, 2, 130},
		{596, 13600, -9632, 90, 0, 0, 2, 130},
		{595, 13056, -8416, 270, 0, 0, 2, 129},
		{595, 13312, -8416, 270, 0, 0, 2, 129},
		{MT_PSO_LASERTOWER, 13632, -7584, 300, 1, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 13632, -7712, 301, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 13632, -7872, 302, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 13632, -8032, 303, 0, 0, 1, 2504},
		{MT_PSO_LASERTOWER, 13632, -8160, 304, 0, 0, 1, 2504},
		{MT_PSO_CARDREADER, 13504, -8256, 180, 0, 0, 1, 2503},
		{MT_PSO_UNLOCKCARD, 13216, -8032, 1, 0, 0, 2, 2502},
		{MT_PSO_ICESTABBER, 13920, -4768, 270, 1, 0, 0, 2552},
		{MT_PSO_ROOMANCHOR, 12448, -3392, 7, 1, 0, 0, 2500},
		{MT_PSO_ROOMANCHOR, 15936, -6816, 7, 1, 0, 0, 2500},
		{MT_PSO_CRATE, 12832, -5152, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 12896, -4768, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 13024, -4480, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 13280, -4192, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 12896, -5440, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 13024, -5760, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 13248, -5984, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 13568, -6144, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 13952, -6176, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 14336, -6144, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 14688, -6048, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 14944, -5792, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 15040, -5536, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 15072, -5248, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 15040, -4960, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 14880, -4672, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 14688, -4416, 0, 1, 0, 0, 2505},
		{MT_PSO_CRATE, 14432, -4192, 0, 1, 0, 0, 2505},
		{MT_PSO_TELEPORTER, 13920, -4032, 1, 1, 0, 1, 2510},
		{MT_PSO_TELEPORTER, 14240, -7712, 255, 0, 0, 0, 2510},
		{MT_PSO_TELEPORT_DEST, 13920, -5664, 255, 0, 0, 0, 2511},
		{MT_PSO_UNLOCKCARD, 1920, -8384, 1, 0, 0, 1, 2502},
		{MT_PSO_CARDREADER, 1952, -4608, 0, 0, 0, 1, 2503},
		{MT_PSO_UNLOCKCARD, 4384, -2336, 1, 0, 0, 1, 2502},
		{MT_PSO_CARDREADER, 4512, -1952, 180, 0, 0, 1, 2503},
	},
})